# include "stdio.h"
# define U(x) ((unsigned char)(x))
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# define YYLMAX 200
# define output(c) (void)putc(c,yyout)
#if defined(__cplusplus) || defined(__STDC__)
	int yyback(int *, int);
	int yyinput(void);
	int yylook(void);
	void yyoutput(int);
	int yyracc(int);
	int yyreject(void);
	void yyunput(int);

#ifndef __STDC__
#ifndef yyless
	void yyless(int);
#endif
#ifndef yywrap
	int yywrap(void);
#endif
#endif

#endif
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
# define ECHO (void)fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
int yyleng; extern char yytext[];
int yymorfg;
extern char *yysptr, yysbuf[];
int yytchar;
FILE *yyin, *yyout;
extern int yylineno;
struct yysvf { 
	struct yywork *yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;


/* Copyright (c) 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004 by Arkkra Enterprises */

/* All rights reserved */


/* lexer for music publication program. Recognizes and returns all the
 * tokens needed by yacc. */

#include <ctype.h>
#include "rational.h"
#include "ytab.h"
#include "defines.h"
#include "structs.h"
#include "globals.h"



/* in order to reduce the number of terminal symbols so yacc won't blow
 * up, we map several similar tokens to the same return code. We then
 * use the yylval variable to say which specific one of the set
 * was actually in the input */
extern YYSTYPE yylval;


/* the default lex buffer is sort of small. Make a bit bigger to be safe */
#undef YYLMAX
#define YYLMAX BUFSIZ


/* if expanding a macro, don't want to increment yylineno, so need to redefine
 * the input macro. */
#undef input
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno+=not_in_mac(1),yytchar):yytchar)==EOF?0:yytchar)
#undef unput
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno-=not_in_mac(-1);*yysptr++=yytchar;}


static int Ifdef_count = 0;	/* how many ifdefs in progress */
static int Raw_string = NO;	/* YES if doing raw string (not expanding
				 * any non-ASCII into Mup escapes) */

static int get_a_param P((char *macname));
static void skipwhite P((void));
static void to_eol P((void));
static int skip2else P((void));
static int oddbs P((void));
static void xpand_non_ascii P((void));
static void ignore P((void));
# define YYNEWLINE 10
yylex(){
int nstr;
while((nstr = yylook()) >= 0)
switch(nstr){
case 0:
if(yywrap()) return(0); break;
case 1:

	{ yylval.intval = FONT_TR; return(T_FONT); }
break;
case 2:

	{ yylval.intval = FONT_TB; return(T_FONT); }
break;
case 3:

{ yylval.intval = FONT_TX; return(T_FONT); }
break;
case 4:

	{ yylval.intval = FONT_TI; return(T_FONT); }
break;
case 5:

	{ yylval.intval = BASE_TIMES; return(T_FFAMILY); }
break;
case 6:

{ yylval.intval = BASE_AVANTGARDE; return(T_FFAMILY); }
break;
case 7:

	{ yylval.intval = BASE_COURIER; return(T_FFAMILY); }
break;
case 8:

{ yylval.intval = BASE_HELVETICA; return(T_FFAMILY); }
break;
case 9:

	{ yylval.intval = BASE_BOOKMAN; return(T_FFAMILY); }
break;
case 10:

{ yylval.intval = BASE_NEWCENTURY; return(T_FFAMILY); }
break;
case 11:

{ yylval.intval = BASE_PALATINO; return(T_FFAMILY); }
break;
case 12:

{
			/* set up include using filename with quotes stripped */
			yytext[yyleng - 1] = '\0';
			includefile(strchr(yytext, '"') + 1);
		}
break;
case 13:

{
			yytext[yyleng - 1] = '\0';
			parse_font_file(strchr(yytext, '"') + 1);
		}
break;
case 14:

	case 15:

{ yylval.intval = DIMINISHED; return(T_XPOS_INT); }
break;
case 16:

	case 17:

{ yylval.intval = AUGMENTED; return(T_XPOS_INT); }
break;
case 18:

	case 19:

	{ yylval.intval = PERFECT; return(T_XPOS_INT); }
break;
case 20:

	case 21:

	{ yylval.intval = MINOR; return(T_XPOS_INT); }
break;
case 22:

	case 23:

	{ yylval.intval = MAJOR; return(T_XPOS_INT); }
break;
case 24:

	return(T_TITLE);
break;
case 25:

	return(T_SCORE);
break;
case 26:

	return(T_STAFF);
break;
case 27:

	return(T_VOICE);
break;
case 28:

	{ yylval.intval = C_HEADER; return(T_BLOCKHEAD); }
break;
case 29:

	{ yylval.intval = C_FOOTER; return(T_BLOCKHEAD); }
break;
case 30:

	{ yylval.intval = C_HEAD2; return(T_BLOCKHEAD); }
break;
case 31:

	{ yylval.intval = C_FOOT2; return(T_BLOCKHEAD); }
break;
case 32:

	{ yylval.intval = C_TOP; return(T_BLOCKHEAD); }
break;
case 33:

	{ yylval.intval = C_BOT; return(T_BLOCKHEAD); }
break;
case 34:

	{ yylval.intval = C_TOP2; return(T_BLOCKHEAD); }
break;
case 35:

	{ yylval.intval = C_BOT2; return(T_BLOCKHEAD); }
break;
case 36:

	{ yylval.intval = C_BLOCK; return(T_BLOCKHEAD); }
break;
case 37:

	return(T_GRIDS);
break;
case 38:

	return(T_MUSIC);
break;
case 39:

return(T_HEADSHAPES);
break;
case 40:

	return(T_NUMBER);
break;
case 41:

	return(T_EQUAL);
break;
case 42:

	return(T_SEMICOLON);
break;
case 43:

	case 44:

	case 45:

	return(T_NEWLINE);
break;
case 46:

	return(T_COLON);
break;
case 47:

	return(T_COMMA);
break;
case 48:

	return(T_LBRACKET);
break;
case 49:

	return(T_RBRACKET);
break;
case 50:

	return(T_LBRACE);
break;
case 51:

	return(T_RBRACE);
break;
case 52:

	return(T_LPAREN);
break;
case 53:

	return(T_RPAREN);
break;
case 54:

	return(T_EXCLAM);
break;
case 55:

{
			/* string: handle embedded backslashed quotes */
			if (yytext[yyleng-2] == '\\' && oddbs() == YES) {
				unput('"');
				yyleng -= 2;
				yymore();
			}
			else {
				xpand_non_ascii();
				if (yyleng > YYLMAX) {
					l_ufatal(Curr_filename, yylineno,
							"text string too long");
				}
				return(T_STRING);
			}
		}
break;
case 56:

	return(T_DASH);
break;
case 57:

	return(T_PLUS);
break;
case 58:

	return(T_CUE);
break;
case 59:

	return(T_GRACE);
break;
case 60:

	return(T_XNOTE);
break;
case 61:

	return(T_DIAM);
break;
case 62:

	return(T_HO);
break;
case 63:

	return(T_HS);
break;
case 64:

		{ yylval.intval = L_NORMAL; return(T_TIE); }
break;
case 65:

	{ yylval.intval = L_DOTTED; return(T_TIE); }
break;
case 66:

	{ yylval.intval = L_DASHED; return(T_TIE); }
break;
case 67:

		{ yylval.intval = L_NORMAL; return(T_SLUR); }
break;
case 68:

{ yylval.intval = L_DOTTED; return(T_SLUR); }
break;
case 69:

{ yylval.intval = L_DASHED; return(T_SLUR); }
break;
case 70:

	return(T_WITH);
break;
case 71:

	{ yylval.intval = PL_ABOVE; return(T_PLACE); }
break;
case 72:

	{ yylval.intval = PL_BELOW; return(T_PLACE); }
break;
case 73:

	{ yylval.intval = PL_BETWEEN; return(T_PLACE); }
break;
case 74:

	return(T_ALL);
break;
case 75:

	return(T_UP);
break;
case 76:

	return(T_DOWN);
break;
case 77:

	return(T_LEN);
break;
case 78:

	return(T_SLASHMARK);
break;
case 79:

	return(T_ALT);
break;
case 80:

	return(T_BM);
break;
case 81:

	return(T_ESBM);
break;
case 82:

	return(T_EBM);
break;
case 83:

	{ yylval.intval = PAD; return(T_PAD); }
break;
case 84:

	return(T_HAT);
break;
case 85:

		{ yylval.intval = L_NORMAL; return(T_TILDE); }
break;
case 86:

	{ yylval.intval = L_DOTTED; return(T_TILDE); }
break;
case 87:

	{ yylval.intval = L_DASHED; return(T_TILDE); }
break;
case 88:

	return(T_QUESTION);
break;
case 89:

	return(T_DOT);
break;
case 90:

	{ yylval.intval = 2; return(T_MULTIWHOLE); }
break;
case 91:

	{ yylval.intval = 4; return(T_MULTIWHOLE); }
break;
case 92:

	return(T_LET_M);
break;
case 93:

	return(T_LET_R);
break;
case 94:

	return(T_LET_S);
break;
case 95:

	return(T_LET_U);
break;
case 96:

	return(T_PITCH);
break;
case 97:

	return(T_SHARP);
break;
case 98:

	return(T_AMPERSAND);
break;
case 99:

	return(T_LET_N);
break;
case 100:

	return(T_LET_X);
break;
case 101:

return(T_LETTER);
break;
case 102:

	return(T_RPT);
break;
case 103:

return(T_LVAR);
break;
case 104:

	return(T_DBLFLAT);
break;
case 105:

	return(T_LYRICS);
break;
case 106:

{ yylval.intval = NO; return(T_SCOREFEED); }
break;
case 107:

	{ yylval.intval = YES; return(T_SCOREFEED); }
break;
case 108:

return(T_MULTIREST);
break;
case 109:

	{ yylval.intval = SINGLEBAR; return(T_BARTYPE); }
break;
case 110:

	{ yylval.intval = DOUBLEBAR; return(T_BARTYPE); }
break;
case 111:

{ yylval.intval = REPEATSTART; return(T_BARTYPE); }
break;
case 112:

{ yylval.intval = REPEATEND; return(T_BARTYPE); }
break;
case 113:

{ yylval.intval = REPEATBOTH; return(T_BARTYPE); }
break;
case 114:

{ yylval.intval = INVISBAR; return(T_BARTYPE); }
break;
case 115:

	{ yylval.intval = ENDBAR; return(T_BARTYPE); }
break;
case 116:

	{ yylval.intval = RESTART; return(T_BARTYPE); }
break;
case 117:

	case 118:

return(T_REHEARSAL);
break;
case 119:

	return(T_RNUM);
break;
case 120:

	return(T_LET);
break;
case 121:

	return(T_MNUM);
break;
case 122:

	return(T_ENDING);
break;
case 123:

return(T_ENDENDING);
break;
case 124:

return(T_HIDECHANGES);
break;
case 125:

	{ yylval.intval = L_WIDE; return(T_LINETYPE); }
break;
case 126:

	{ yylval.intval = L_MEDIUM; return(T_LINETYPE); }
break;
case 127:

	{ yylval.intval = L_WAVY; return(T_LINETYPE); }
break;
case 128:

	{ yylval.intval = L_DOTTED; return(T_LINETYPE); }
break;
case 129:

	{ yylval.intval = L_DASHED; return(T_LINETYPE); }
break;
case 130:

	return(T_LINE);
break;
case 131:

	return(T_TO);
break;
case 132:

	return(T_CURVE);
break;
case 133:

	return(T_BULGE);
break;
case 134:

	{ yylval.intval = J_LEFT; return(T_PRINTTYPE); }
break;
case 135:

	{ yylval.intval = J_RIGHT; return(T_PRINTTYPE); }
break;
case 136:

	{ yylval.intval = J_CENTER; return(T_PRINTTYPE); }
break;
case 137:

	{ yylval.intval = J_NONE; return(T_PRINTTYPE); }
break;
case 138:

{ return(T_POSTSCRIPT); }
break;
case 139:

	{ yylval.intval = J_RAGPARA; return(T_PARATYPE); }
break;
case 140:

{ yylval.intval = J_JUSTPARA; return(T_PARATYPE); }
break;
case 141:

return(T_PARAGRAPH);
break;
case 142:

	return(T_NL);
break;
case 143:

	return(T_SLASH);
break;
case 144:

	return(T_CUT);
break;
case 145:

	return(T_COMMON);
break;
case 146:

	{ yylval.intval = NUMSTAFF; return(T_NUMVAR); }
break;
case 147:

	{ yylval.intval = VSCHEME; return(T_VVAR); }
break;
case 148:

	{ yylval.intval = DEFOCT; return(T_NUMVAR); }
break;
case 149:

{ yylval.intval = LYRICSSIZE; return(T_NUMVAR); }
break;
case 150:

{ yylval.intval = SYLPOSITION; return(T_NUMVAR); }
break;
case 151:

	{ yylval.intval = SIZE; return(T_NUMVAR); }
break;
case 152:

{ yylval.intval = MINSTSEP; return(T_NUMVAR); }
break;
case 153:

{ yylval.intval = SCOREPAD; return(T_NUMVAR); }
break;
case 154:

{ yylval.intval = STAFFPAD; return(T_NUMVAR); }
break;
case 155:

{ yylval.intval = CHORDDIST; return(T_NUMVAR); }
break;
case 156:

	{ yylval.intval = DIST; return(T_NUMVAR); }
break;
case 157:

	{ yylval.intval = DYNDIST; return(T_NUMVAR); }
break;
case 158:

{
			l_yyerror(Curr_filename, yylineno,
				"'crescdist' has been renamed 'dyndist'");
			yylval.intval = DYNDIST;
			return(T_NUMVAR);
		}
break;
case 159:

{ yylval.intval = DIVISION; return(T_NUMVAR); }
break;
case 160:

	{ yylval.intval = RELEASE; return(T_NUMVAR); }
break;
case 161:

{ yylval.intval = PANELSPERPAGE; return(T_NUMVAR); }
break;
case 162:

{ yylval.intval = GRIDFRET; return(T_NUMVAR); }
break;
case 163:

{ yylval.intval = RESTCOMBINE; return(T_NUMVAR); }
break;
case 164:

{ yylval.intval = FIRSTPAGE; return(T_NUMVAR); }
break;
case 165:

{ yylval.intval = MINSCSEP; return(T_SCORESEP); }
break;
case 166:

{ yylval.intval = STAFFLINES; return(T_STAFFLINES); }
break;
case 167:

{ yylval.intval = ONTHELINE; return(T_YESNOVAR); }
break;
case 168:

	{ yylval.intval = WARN; return(T_YESNOVAR); }
break;
case 169:

{ yylval.intval = NUMBERMRPT; return(T_YESNOVAR); }
break;
case 170:

{ yylval.intval = PRINTMULTNUM; return(T_YESNOVAR); }
break;
case 171:

{ yylval.intval = GRIDSWHEREUSED; return(T_YESNOVAR); }
break;
case 172:

{ yylval.intval = GRIDSATEND; return(T_YESNOVAR); }
break;
case 173:

	return(T_TAB);
break;
case 174:

{ yylval.intval = TABWHITEBOX; return(T_YESNOVAR); }
break;
case 175:

{ yylval.intval = TIMEUNIT; return(T_TIMEUNIT); }
break;
case 176:

{ yylval.intval = SWINGUNIT; return(T_SWINGUNIT); }
break;
case 177:

{ yylval.intval = TOPMARGIN; return(T_FNUMVAR); }
break;
case 178:

{ yylval.intval = BOTMARGIN; return(T_FNUMVAR); }
break;
case 179:

{ yylval.intval = BOTMARGIN; return(T_FNUMVAR); }
break;
case 180:

{ yylval.intval = LEFTMARGIN; return(T_FNUMVAR); }
break;
case 181:

{ yylval.intval = RIGHTMARGIN; return(T_FNUMVAR); }
break;
case 182:

{ yylval.intval = PACKFACT; return(T_FNUMVAR); }
break;
case 183:

	{ yylval.intval = PACKEXP; return(T_FNUMVAR); }
break;
case 184:

{ yylval.intval = STAFFSCALE; return(T_FNUMVAR); }
break;
case 185:

{ yylval.intval = GRIDSCALE; return(T_FNUMVAR); }
break;
case 186:

	{ yylval.intval = SCALE_FACTOR; return(T_FNUMVAR); }
break;
case 187:

	{ yylval.intval = STEMLEN; return(T_FNUMVAR); }
break;
case 188:

{ yylval.intval = BEAMSLOPE; return(T_2FNUMVAR); }
break;
case 189:

{ yylval.intval = TRANSPOSITION; return(T_TRANSPOSE); }
break;
case 190:

{ yylval.intval = ADDTRANSPOSITION; return(T_TRANSPOSE); }
break;
case 191:

{ yylval.intval = LYRICSALIGN; return(T_FNUMVAR); }
break;
case 192:

{ yylval.intval = PAGEHEIGHT; return(T_FNUMVAR); }
break;
case 193:

{ yylval.intval = PAGEWIDTH; return(T_FNUMVAR); }
break;
case 194:

	{ yylval.intval = UNITS; return(T_UNITS); }
break;
case 195:

	{ yylval.intval = CM; return(T_UNITTYPE); }
break;
case 196:

	{ yylval.intval = INCHES; return(T_UNITTYPE); }
break;
case 197:

{ yylval.intval = ENDINGSTYLE; return(T_ENDSTYLE); }
break;
case 198:

{ yylval.intval = REHSTYLE; return(T_REH_STYLE); }
break;
case 199:

	{ yylval.intval = RS_BOXED; return(T_REHTYPE); }
break;
case 200:

	{ yylval.intval = RS_CIRCLED; return(T_REHTYPE); }
break;
case 201:

	{ yylval.intval = RS_PLAIN; return(T_REHTYPE); }
break;
case 202:

{ yylval.intval = PEDSTYLE; return(T_PEDSTYLE); }
break;
case 203:

	return(T_PEDSTAR);
break;
case 204:

	{ yylval.intval = ENDING_BARRED; return(T_ENDTYPE); }
break;
case 205:

	{ yylval.intval = ENDING_GROUPED; return(T_ENDTYPE); }
break;
case 206:

	{ yylval.intval = BRACELIST; return(T_RANGELISTVAR); }
break;
case 207:

	{ yylval.intval = BRACKLIST; return(T_RANGELISTVAR); }
break;
case 208:

{ yylval.intval = BARSTLIST; return(T_BARSTLISTVAR); }
break;
case 209:

{ yylval.intval = PL_ABOVE; return(T_ORDER); }
break;
case 210:

{ yylval.intval = PL_BELOW; return(T_ORDER); }
break;
case 211:

{ yylval.intval = PL_BETWEEN; return(T_ORDER); }
break;
case 212:

return(T_OTHERTEXT);
break;
case 213:

	{ yylval.intval = SHARPS; return(T_KEY); }
break;
case 214:

	{ yylval.intval = TIME; return(T_TIME); }
break;
case 215:

{ yylval.intval = BEAMSTLIST; return(T_RATNUMLISTVAR); }
break;
case 216:

	{ yylval.intval = VISIBLE; return(T_VISVAR); }
break;
case 217:

{ return(T_WHEREUSED); }
break;
case 218:

	{ yylval.intval = MEASNUM; return(T_YESNOVAR); }
break;
case 219:

{ yylval.intval = CANCELKEY; return(T_YESNOVAR); }
break;
case 220:

	{ yylval.intval = LABEL; return(T_STRVAR); }
break;
case 221:

	{ yylval.intval = LABEL2; return(T_STRVAR); }
break;
case 222:

{ yylval.intval = NOTEHEADS; return(T_STRVAR); }
break;
case 223:

	{ yylval.intval = FONT; return(T_FONTVAR); }
break;
case 224:

{ yylval.intval = FONTFAMILY; return(T_FAMILY); }
break;
case 225:

{ yylval.intval = LYRICSFONT; return(T_FONTVAR); }
break;
case 226:

{ yylval.intval = LYRICSFAMILY; return(T_FAMILY); }
break;
case 227:

{ yylval.intval = MEASNUMSIZE; return(T_NUMVAR); }
break;
case 228:

{ yylval.intval = MEASNUMFONT; return(T_FONTVAR); }
break;
case 229:

{ yylval.intval = MEASNUMFAMILY; return(T_FAMILY); }
break;
case 230:

	{ yylval.intval = CLEF; return(T_CLEFVAR); }
break;
case 231:

	{ return(T_UNSET); }
break;
case 232:

	{ yylval.intval = TREBLE_8A; return(T_CLEF); }
break;
case 233:

	{ yylval.intval = TREBLE; return(T_CLEF); }
break;
case 234:

	{ yylval.intval = TREBLE_8; return(T_CLEF); }
break;
case 235:

{ yylval.intval = FRENCHVIOLIN; return(T_CLEF); }
break;
case 236:

	{ yylval.intval = SOPRANO; return(T_CLEF); }
break;
case 237:

{ yylval.intval = MEZZOSOPRANO; return(T_CLEF); }
break;
case 238:

	{ yylval.intval = ALTO; return(T_CLEF); }
break;
case 239:

	{ yylval.intval = TENOR; return(T_CLEF); }
break;
case 240:

{ yylval.intval = BARITONE; return(T_CLEF); }
break;
case 241:

	{ yylval.intval = BASS; return(T_CLEF); }
break;
case 242:

	{ return(T_DRUM); }
break;
case 243:

	return(T_R_ANGLE);
break;
case 244:

	{ yylval.intval = L_NORMAL; return(T_L_ANGLE); }
break;
case 245:

	{ return(T_L_DBLANGLE); }
break;
case 246:

	{ return(T_R_DBLANGLE); }
break;
case 247:

{ yylval.intval = L_DOTTED; return(T_L_ANGLE); }
break;
case 248:

{ yylval.intval = L_DASHED; return(T_L_ANGLE); }
break;
case 249:

	{ yylval.intval = IN_DOWNWARD; return(T_NOWHERE_SLIDE); }
break;
case 250:

	{ yylval.intval = IN_UPWARD; return(T_NOWHERE_SLIDE); }
break;
case 251:

	{ yylval.intval = OUT_UPWARD; return(T_NOWHERE_SLIDE); }
break;
case 252:

	{ yylval.intval = OUT_DOWNWARD; return(T_NOWHERE_SLIDE); }
break;
case 253:

	return(T_PEDAL);
break;
case 254:

	return(T_MUSSYM);
break;
case 255:

	{ yylval.intval = TM_CHORD; return(T_MODIFIER); }
break;
case 256:

{ yylval.intval = TM_ANALYSIS; return(T_MODIFIER); }
break;
case 257:

	{ yylval.intval = TM_FIGBASS; return(T_MODIFIER); }
break;
case 258:

	{ yylval.intval = TM_DYN; return(T_MODIFIER); }
break;
case 259:

	return(T_PHRASE);
break;
case 260:

	return(T_TIL);
break;
case 261:

	return(T_OCTAVE);
break;
case 262:

	return(T_ROLL);
break;
case 263:

	return(T_MIDI);
break;
case 264:

	return(T_STAR);
break;
case 265:

	to_eol();
break;
case 266:

	define_macro(yytext + 7);
break;
case 267:

		undef_macro(yytext + 6);
break;
case 268:

{
					int result;

					/* do ifdef or ifndef as appropriate */
					if (yytext[2] == 'n') {
						result = ! is_defined(yytext + 7
							+ strspn(yytext + 7, " \t"));
					}
					else {
						result = is_defined(yytext + 6
							+ strspn(yytext + 6, " \t"));
					}

					if (result) {
						/* do stuff till else or endif */
						Ifdef_count++;
					}
					else {
						/* skip ifdef-ed part */
						if (skip2else() == YES) {
							/* found an else */
							Ifdef_count++;
						}
						/* if found an endif instead,
						 * we just continue */
					}
				}
break;
case 269:

			{
					if (Ifdef_count < 1) {
						yyerror("else without ifdef");
					}
					else {
						Ifdef_count--;
						if (skip2else() == YES) {
							yyerror("else without ifdef");
						}
					}
				}
break;
case 270:

			{
					if (Ifdef_count < 1) {
						yyerror("endif without ifdef");
					}
					else {
						Ifdef_count--;
					}
				}
break;
case 271:

	call_macro(yytext);
break;
case 272:

{
				if (isspace(yytext[1]) ||
						isspace(yytext[yyleng-2])) {
					yyerror("spaces not allowed inside ` ` marks");
				}
				else {
					/* We only need the leading ` to tell
					 * it is a quoted macro parm,
					 * and it's easier to deal with later
					 * if there is no trailing `
					 * so strip off the trailing. */
					yytext[yyleng - 1] = '\0';
					call_macro(yytext);
				}
			}
break;
case 273:

	{ yylval.intval = strlen(yytext); return(T_TICKS); }
break;
case 274:

{
			/* ignore backslashed newlines;
			 * allow white space after backslash */
			ignore();
		}
break;
case 275:

		{
				/* in case we get control-Z from DOS */
				ignore();
			}
break;
case 276:

	{
				/* ignore extra white space */
				ignore();
			}
break;
case 277:

	{
			if (isgraph(yytext[0])) {
				l_yyerror(Curr_filename, yylineno,
					"invalid character in input: '%c'",
					yytext[0]);
			}
			else {
				l_yyerror(Curr_filename, yylineno,
					"invalid character in input: 0x%x",
					(int) yytext[0]);
			}
		}
break;
case -1:
break;
default:
(void)fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }
/* end of yylex */

/* comments go to end of line. This can be done with a simple
 * lex pattern, but when taken with all the other patterns, lex blows
 * up because of too many right contexts. So we do this special case
 * with this function.
 */

static void
to_eol()

{
	while ((yytext[yyleng] = yyinput()) != '\n' && yytext[yyleng] != 0) {
		if (++yyleng >= YYLMAX) {
			l_ufatal(Curr_filename, yylineno, "input line too long");
		}
		if (yytext[yyleng-1] == '\r') {
			/* If the \r is by itself, treat like a newline */
			char c;
			if ((c = yyinput()) == '\n') {
				yytext[--yyleng] = '\n';
				break;
			}
			else if (c != 0) {
				unput(c);
			}
		}
	}

	if (yytext[yyleng] == 0) {
		yyerror("unexpected end of file");
	}
	else {
		if (yyleng > 0 && yytext[yyleng - 1] == '\\') {
			/* if backslashed newline, replace with real newline
			 * and continue */
			yytext[--yyleng] = '\n';
			to_eol();
		}
		/* handle DOS style backslashed \r\n */
		else if (yyleng > 1 && yytext[yyleng - 1] == '\r'
						&& yytext[yyleng - 2] == '\\') {
			yytext[yyleng - 2] = '\r';
			yytext[--yyleng] = '\n';
			to_eol();
		}

		/* put newline back onto input stream */
		unput('\n');
	}

	yytext[yyleng] = '\0';

	if (Preproc == YES && Ppcomments == YES) {
		printf("%s", yytext);
	}
}


/* Save macro text in specified file.
 * @ is used to mark end of macro definition.
 * Returns YES if there appeared to be any references to
 * macro parameters to be quoted.
 * (See the comment above the QS_ #defines in macros.c for more details.) */

int
save_macro(file)

FILE *file;	/* put macro text into this file */

{
	int c;				/* character read from macro */
	int num_backslashes = 0;
	int has_quoted_parameters = NO;


	while ((c = input()) != 0) {
		if (c == '@') {
			/* if had a backslash before it, use real @ */
			if (num_backslashes == 1) {
				putc(c, file);
				num_backslashes = 0;
			}
			else {	
				/* reached end of macro definition */
				return(has_quoted_parameters);
			}
		}
		else {
			if (c == '\\') {
				num_backslashes++;
				if (num_backslashes == 2) {
					putc(c, file);
					num_backslashes = 0;
				}
			}
			else {
				if (num_backslashes == 1) {
					putc('\\', file);
				}
				putc(c, file);
				num_backslashes = 0;
				if (c == '`') {
					has_quoted_parameters = YES;
				}
			}
		}
	}

	yyerror("unterminated macro");
	return(has_quoted_parameters);
}


/* collect the parameter names on the definition of a macro with parameters */

void
get_parameters(macname)

char *macname;		/* name of macro being defined */

{
	while (get_a_param(macname) == YES) {
		;
	}
}

static int
get_a_param(macname)

char *macname;

{
	int c;		/* input character */
	int index;	/* into name buffer */


	/* skip leading white space */
	skipwhite();

	/* collect macro-like parameter names (upper case, digits, or
	 * underscore, starting with upper case), delimited by comma
	 * and ended by close parenthesis. */
	while ((c = input()) != '\0') {
		if (isupper(c)) {
			yytext[0] = c;
			index = 1;
			while ((c = input()) != '\0') {
				if (isupper(c) || isdigit(c) || c == '_') {
					yytext[index++] = c;
				}
				else  {
					/* found end of parameter name */
					unput(c);
					yytext[index] = '\0';
					add_parameter(macname, yytext);

					/* skip white space */
					skipwhite();

					/* next better be , or ) */
					if ((c = input()) != ',' && c != ')') {
						l_yyerror(Curr_filename, yylineno,
							"unexpected character '%c' in parameter list for macro %s",
							c, macname);
						return(NO);
					}
					if (c == ')') {
						/* return to input so we can
						 * read on next call to know
						 * we are at end of list */
						unput(c);
					}
					return(YES);
				}
			}
		}
		else if (c == ')') {
			/* end of parameter list */
			return(NO);
		}
		else {
			l_yyerror(Curr_filename, yylineno,
				"illegal macro parameter name starting at character '%c'", c);
			return(NO);
		}
	}
	yyerror("unexpected end-of-file in macro parameter list");
	return(NO);
}


/* Read input, skipping any white space. White space is space, tab, return,
 * backslashed return, newline, or backslashed newline.
 * Backslashed anything else will leave the backslash in the input
 * without the thing that followed it.
 */

 
static void
skipwhite()

{
	int c;

	while ((c = input()) != '\0') {
		if (c == ' ' || c == '\t' || c == '\n' || c == '\r') {
			continue;
		}

		if (c == '\\') {
			if ((c = input()) == '\n' || c == '\r' ) {
				/* backslashed newline/return is white space */
				continue;
			}
			else {
				unput('\\');
				return;
			}
		}
		/* non-space. Stuff back into input and return */
		unput(c);
		return;
	}
}



/* collect arguments to a call to a macro with parameters */

int
get_mac_arguments(macname, num_args)

char *macname;		/* name of the macro, to use in error messages */
int num_args;		/* number of arguments expected */

{
	int c;		/* input character */
	char *argbuff;	/* for storing argument */
	int n;		/* number of arguments collected so far */


	/* first skip any white space before the opening parenthesis */
	skipwhite();

	/* next thing better be open parenthesis */
	if ((c = input()) != '(') {

		l_yyerror(Curr_filename, yylineno,
			"macro %s has parameters, but has no '(' on call",
			macname);

		/* Trying to parse anything more in this file might be
		 * almost hopeless. But we'll try just skipping to end of
		 * the line and returning failure and hope for the best. */
		while (((c = input()) != '\0') && (c != '\n') && (c != '\r')) {
			;
		}
		return(NO);
	}

	/* init to no argument collected. Space will be malloc-ed when needed */
	argbuff = (char *) 0;
	n = 0;

	/* Now collect arguments. Read and process input
	 * one character at a time */
	while ((c = input()) != '\0') {
		switch (c) {
		case '\\':
			/* something that has been escaped with a backslash.
			 * Get the next character and do appropriate escape. */
			switch (c = input()) {
			default:
				/* some unexpected backslashed thing */
				l_warning(Curr_filename, yylineno,
					"dubious escape \\%c in argument %d of macro %s",
					c, n+1, macname);
				/* fall through to use the literal, to be
				 * sort of consistent with how C handles
				 * such dubious escapes */
				/*FALLTHRU*/

			case ',':	/* would normally mean end of argument */
			case ')':	/* would normally mean end of argument list */
			case '\\':	/* user wants a real backslash */
				/* escaped to allow literal, so copy the
				 * character without backslash to buffer */
				argbuff = add2argbuff(argbuff, c);
				break;

			case '\n':
				/* user wanted to put a newline in the input
				 * to make it look better, but doesn't really
				 * want a newline here in the argument text,
				 * so just skip over this character */
				break;

			case '\r':
				/* If by itself, treat like newline.
				 * If immediately followed by a newline,
				 * treat the pair like newline.
				 */
				if ((c = input()) != '\n') {
					/* Followed by something other than
					 * newline, so push back into input.
					 */
					if (c != EOF) {
						unput(c);
					}
				}
				break;
			case '\0':
				l_yyerror(Curr_filename, yylineno,
					"unexpected end of file in macro %s argument %d",
					macname, n + 1);
				return(NO);
			}
			break;

		case ',':
			/* This marks the end of an argument.
			 * Process this argument, then reset for next one */
			if (++n <= num_args) {
				set_parm_value(macname, argbuff, n);
			}
			else {
				/* discard this one. It's extra. But wait
				 * to print error until we find the ),
				 * so if they have lots of extras we only
				 * print one message */
				if (argbuff != (char *) 0) {
					FREE(argbuff);
				}
			}

			/* reset for next argument */
			argbuff = (char *) 0;
			break;

		case ')':
			/* this marks end of arguments. Save the last one
			 * collected and signal success */
			if (++n == num_args) {
				/* good. got exactly the right number of
				 * arguments. Save the last one and
				 * declare victory */
				set_parm_value(macname, argbuff, n);
				return(YES);
			}
			else {
				l_yyerror(Curr_filename, yylineno,
					"too %s arguments to macro %s (expected %d, got %d)",
					((n < num_args) ? "few" : "many"),
					macname, num_args, n);
			}
			return(NO);

		default:
			/* ordinary character. Save it away */
			argbuff = add2argbuff(argbuff, c);
			break;
		}
	}

	l_yyerror(Curr_filename, yylineno, "unexpected end of file in call to %s macro",
		macname);
	return(NO);
}


/* skip input until find an else or endif. If find else, return YES, if find
 * endif or end of file, return NO */
/* It probably would be possible to get lex to do this pattern matching with
 * appropriate start conditions, but it seems like too much trouble to figure
 * that out. Just need to look for 2 simple patterns, so do simple state
 * machine */

typedef enum { STATE_NONE, STATE_E, STATE_EL, STATE_ELS, STATE_EN,
		STATE_END, STATE_ENDI, STATE_I, STATE_IF, STATE_IFD,
		STATE_IFDE } STATE;

static int
skip2else()

{
	int c;				/* char read from input */
	STATE state = STATE_NONE;


	/* read characters. Based on current character and state, go into
	 * new state if appropriate. */
	while ((c = yyinput()) != 0) {

		switch (c) {

		case 'e':
			if (state == STATE_ELS) {
				return(YES);
			}
			else if (state == STATE_IFD) {
				state = STATE_IFDE;
			}
			else {
				state = STATE_E;
			}
			break;

		case 'l':
			state = (state == STATE_E ? STATE_EL : STATE_NONE);
			break;

		case 's':
			state = (state == STATE_EL ? STATE_ELS : STATE_NONE);
			break;

		case 'n':
			if (state == STATE_E) {
				state = STATE_EN;
			}
			else if (state == STATE_IF) {
				/* for ifndef. Treat this like ifdef. There is
				 * a tiny bug here in that user could input
				 * ifnnndef and we would interpret that as
				 * ifndef. However, since if we're in this
				 * function, we are skipping stuff that is
				 * ifdef-ed out, who cares if we miss some
				 * off-the-wall syntax error? */
				;
			}
			else {
				state = STATE_NONE;
			}
			break;

		case 'd':
			if (state == STATE_EN) {
				state = STATE_END;
			}
			else if (state == STATE_IF) {
				state = STATE_IFD;
			}
			else {
				state = STATE_NONE;
			}
			break;

		case 'i':
			state = (state == STATE_END ? STATE_ENDI : STATE_I);
			break;

		case 'f':
			if (state == STATE_ENDI) {
				return(NO);
			}
			else if (state == STATE_I) {
				state = STATE_IF;
			}
			else if (state == STATE_IFDE) {
				if (skip2else() == YES) {
					if (skip2else() == YES) {
						yyerror("else without ifdef");
					}
				}
			}
			else {
				state = STATE_NONE;
			}
			break;

		default:
			state = STATE_NONE;
			break;
		}
	}

	/* end of file */
	yyerror("unexpected end-of-file: missing endif");
	return(NO);
}


/* at the very end, Ifdef_count better be zero */

void
chk_ifdefs()

{
	if (Ifdef_count != 0) {
		yyerror("missing endif");
	}
}


/* check if there is an odd number of backslashes starting before the final
 * double quote. If so, return YES--the last backslash applies to the double
 * quote. Otherwise return NO, because the backslash was itself backslashed
 * which means user wants to end string with a backslash */

static int
oddbs()

{
	int i;
	int bscount = 0;	/* count of backslashes */

	for (i = yyleng - 2; i >= 0; i--) {
		if (yytext[i] == '\\') {
			bscount++;
		}
		else {
			break;
		}
	}
	return ((bscount & 1) ? YES: NO);
}


/* Mapping of Latin-1 non-ASCII characters to their Mup names. If Mup
 * doesn't support the value, or the value is undefined in Latin-1,
 * value in this table is 0. */
static char *latin1_to_mup_name[] = {
	/* 128 */	0,
	/* 129 */	0,
	/* 130 */	0,
	/* 131 */	0,
	/* 132 */	0,
	/* 133 */	0,
	/* 134 */	0,
	/* 135 */	0,
	/* 136 */	0,
	/* 137 */	0,
	/* 138 */	0,
	/* 139 */	0,
	/* 140 */	0,
	/* 141 */	0,
	/* 142 */	0,
	/* 143 */	0,
	/* 144 */	0,
	/* 145 */	0,
	/* 146 */	0,
	/* 147 */	0,
	/* 148 */	0,
	/* 149 */	0,
	/* 150 */	0,
	/* 151 */	0,
	/* 152 */	0,
	/* 153 */	0,
	/* 154 */	0,
	/* 155 */	0,
	/* 156 */	0,
	/* 157 */	0,
	/* 158 */	0,
	/* 159 */	0,
	/* 160 */	0,
	/* 161 */	"exclamdown",
	/* 162 */	0,
	/* 163 */	"sterling",
	/* 164 */	0,
	/* 165 */	"yen",
	/* 166 */	0,
	/* 167 */	0,
	/* 168 */	"dieresis",
	/* 169 */	"copyright",
	/* 170 */	"ordfeminine",
	/* 171 */	"<<",
	/* 172 */	0,
	/* 173 */	"emdash",
	/* 174 */	0,
	/* 175 */	"macron",
	/* 176 */	"ring",
	/* 177 */	0,
	/* 178 */	0,
	/* 179 */	0,
	/* 180 */	"acute",
	/* 181 */	0,
	/* 182 */	0,
	/* 183 */	0,
	/* 184 */	"cedilla",
	/* 185 */	0,
	/* 186 */	0,
	/* 187 */	">>",
	/* 188 */	0,
	/* 189 */	0,
	/* 190 */	0,
	/* 191 */	"questiondown",
	/* 192 */	"A`",
	/* 193 */	"A'",
	/* 194 */	"A^",
	/* 195 */	"A~",
	/* 196 */	"A:",
	/* 197 */	"Ao",
	/* 198 */	"AE",
	/* 199 */	"C,",
	/* 200 */	"E`",
	/* 201 */	"E'",
	/* 202 */	"E^",
	/* 203 */	"E:",
	/* 204 */	"I`",
	/* 205 */	"I'",
	/* 206 */	"I^",
	/* 207 */	"I:",
	/* 208 */	0,
	/* 209 */	0,
	/* 210 */	"N~",
	/* 211 */	"O`",
	/* 212 */	"O'",
	/* 213 */	"O^",
	/* 214 */	"O~",
	/* 215 */	"O:",
	/* 216 */	"U`",
	/* 217 */	"U'",
	/* 218 */	"U^",
	/* 219 */	"U:",
	/* 220 */	0,
	/* 221 */	0,
	/* 222 */	0,
	/* 223 */	0,
	/* 224 */	"a`",
	/* 225 */	"a'",
	/* 226 */	"a^",
	/* 227 */	"a~",
	/* 228 */	"a:",
	/* 229 */	"ao",
	/* 230 */	"ae",
	/* 231 */	"c,",
	/* 232 */	"e`",
	/* 233 */	"e'",
	/* 234 */	"e^",
	/* 235 */	"e:",
	/* 236 */	"i`",
	/* 237 */	"i'",
	/* 238 */	"i^",
	/* 239 */	"i:",
	/* 240 */	0,
	/* 241 */	"n~",
	/* 242 */	"o`",
	/* 243 */	"o'",
	/* 244 */	"o^",
	/* 245 */	"o~",
	/* 246 */	"o:",
	/* 247 */	0,
	/* 248 */	"o/",
	/* 249 */	"u`",
	/* 250 */	"u'",
	/* 251 */	"u^",
	/* 252 */	"u:",
	/* 253 */	0,
	/* 254 */	0,
	/* 255 */	"y:"
};

/* This function goes through the string currently in yytext, and if it finds
 * any non-ASCII characters that can be transformed into the non-ASCII
 * characters that Mup supports through the \(....) escape mechanism,
 * it replaces them with the appropriate escape strings.
 * This functionality probably logically belongs in fix_string(),
 * but for historical reasons, that function is not allowed
 * to increase the length of a string,
 * so it's easier to do this step separately.
 */

static void
xpand_non_ascii()
{
	int index;			/* walk through yytext */
	int start;			/* index of first non-ascii */
	int value;			/* value of a character */
	char *replacement;		/* Mup's name for the non_ascii */
	static char *tmp_buff = 0;	/* for expanded version */
	int tmp_index;			/* index into tmp_buff */

	if (Raw_string == YES) {
		/* Collecting a string for something like raw PostScript,
		 * that shouldn't be converted. */
		return;
	}

	/* see if any non-ascii */
	for (index = 0; index < yyleng; index++) {
		if (yytext[index] & 0x80) {
			break;
		}
	}

	if (index == yyleng) {
		/* no non-ascii in current string, so leave it as is */
		return;
	}

	/* If we don't have a buffer yet, allocate it. If an input file
	 * has no non-ascii in it at all, we'll never get here, and no
	 * memory will be wasted on a buffer we don't need. If we do get
	 * here, chances are there will be lots more non-ascii, so we
	 * keep the buffer around, rather than constantly doing malloc/free. */
	if (tmp_buff == 0) {
		MALLOCA(char, tmp_buff, YYLMAX);
	}

	/* only need to rewrite the part of the string
	 * beyond the first non-ascii, so remember where we are now */
	start = index;

	/* walk through, converting non-ascii to their Mup names */
	for (tmp_index = 0; index < yyleng; index++) {

		if (yytext[index] & 0x80) {
			/* Look up replacement. The replacement table
			 * only contains entries for 128-255,
			 * so adjust the value of the non-ascii character
			 * to get the appropriate array offset. */
			value = ((int)(yytext[index])) & 0xff;
			replacement = latin1_to_mup_name[value - 128];

			if (replacement == (char *) 0) {
				/* Apparently user is able to input a
				 * character that Mup doesn't support... */
				l_yyerror(Curr_filename, yylineno,
					"unsupported non-ASCII character (0x%x) in string",
					yytext[index] & 0xff);
			}
			else {
				(void) sprintf(tmp_buff + tmp_index, "\\(%s)",
								replacement);
				tmp_index += strlen(replacement) + 3;
			}
		}
		else {
			/* normal ASCII character; copy as is */
			tmp_buff[tmp_index++] = yytext[index];
		}
	}

	/* Now we can copy the expanded string back into yytext and update
	 * yyleng so that all later code will think the user typed in the
	 * expanded version themselves. */
	(void) strncpy(yytext + start, tmp_buff, tmp_index);
	yyleng = start + tmp_index;
	yytext[yyleng] = '\0';
}


/* push a character back into input. This allows another C file to
 * access the unput macro */

void
pushback(c)

int c;

{
	unput(c);
}


/* this function will do nothing unless the "preprocessor only" flag is on,
 * in which case it will print the current token
 */

static void
ignore()

{
	if (Preproc == YES) {
		printf("%s", yytext);
	}
}


/* When collecting raw PostScript, we don't want to convert non-ASCII to
 * Mup escapes. These functions turn the raw processing on and off. */

void
begin_raw()
{
	Raw_string = YES;
}

void
end_raw()
{
	Raw_string = NO;
}
int yyvstop[] = {
0,

277,
0,

276,
277,
0,

45,
0,

277,
278,
0,

43,
277,
0,

275,
277,
0,

54,
277,
0,

277,
0,

97,
277,
0,

98,
277,
0,

273,
277,
0,

52,
277,
0,

53,
277,
0,

264,
277,
0,

57,
277,
0,

47,
277,
0,

56,
277,
0,

89,
277,
0,

143,
277,
0,

40,
277,
0,

40,
277,
0,

40,
277,
0,

46,
277,
0,

42,
277,
0,

244,
277,
0,

41,
277,
0,

243,
277,
0,

88,
277,
0,

271,
277,
0,

48,
277,
0,

277,
0,

49,
277,
0,

84,
277,
0,

277,
0,

277,
0,

96,
277,
0,

96,
277,
0,

96,
277,
0,

96,
277,
0,

96,
277,
0,

96,
277,
0,

96,
277,
0,

101,
277,
0,

101,
277,
0,

101,
277,
0,

101,
277,
0,

101,
277,
0,

92,
277,
0,

99,
277,
0,

101,
277,
0,

101,
277,
0,

101,
277,
0,

93,
277,
0,

94,
277,
0,

101,
277,
0,

95,
277,
0,

101,
277,
0,

101,
277,
0,

100,
277,
0,

50,
277,
0,

51,
277,
0,

85,
277,
0,

44,
0,

55,
0,

104,
0,

273,
0,

265,
0,

250,
0,

40,
0,

245,
0,

246,
0,

271,
0,

274,
0,

249,
0,

103,
0,

80,
0,

195,
0,

62,
0,

63,
0,

251,
0,

252,
0,

142,
0,

131,
0,

75,
0,

90,
0,

91,
0,

272,
0,

74,
0,

79,
0,

16,
0,

109,
0,

58,
0,

144,
0,

14,
0,

258,
0,

82,
0,

213,
0,

77,
0,

120,
0,

22,
0,

20,
0,

119,
0,

83,
0,

18,
0,

117,
0,

1,
0,

102,
0,

173,
0,

64,
0,

260,
0,

32,
0,

238,
0,

241,
0,

2,
0,

230,
0,

61,
0,

156,
0,

76,
0,

242,
0,

269,
0,

81,
0,

223,
0,

4,
0,

134,
0,

130,
0,

263,
0,

121,
0,

262,
0,

151,
0,

67,
0,

214,
0,

34,
0,

168,
0,

127,
0,

125,
0,

70,
0,

71,
0,

72,
0,

36,
0,

199,
0,

206,
0,

133,
0,

255,
0,

132,
0,

270,
0,

59,
0,

37,
0,

220,
0,

23,
0,

21,
0,

38,
0,

253,
0,

201,
0,

137,
0,

135,
0,

186,
0,

25,
0,

78,
0,

26,
0,

239,
0,

5,
0,

24,
0,

194,
0,

231,
0,

27,
0,

60,
0,

204,
0,

33,
0,

136,
0,

145,
0,

129,
0,

110,
0,

148,
0,

128,
0,

115,
0,

122,
0,

29,
0,

28,
0,

196,
0,

221,
0,

105,
0,

126,
0,

254,
0,

261,
0,

259,
0,

139,
0,

146,
0,

233,
0,

232,
0,

73,
0,

9,
0,

35,
0,

207,
0,

200,
0,

7,
0,

248,
0,

87,
0,

247,
0,

86,
0,

157,
0,

257,
0,

31,
0,

205,
0,

30,
0,

268,
0,

218,
0,

107,
0,

183,
0,

203,
0,

19,
0,

160,
0,

116,
0,

236,
0,

187,
0,

234,
0,

267,
0,

216,
0,

147,
0,

256,
0,

240,
0,

208,
0,

3,
0,

266,
0,

159,
0,

162,
0,

114,
0,

106,
0,

182,
0,

11,
0,

202,
0,

198,
0,

153,
0,

165,
0,

154,
0,

152,
0,

175,
0,

17,
0,

188,
0,

215,
0,

178,
0,

219,
0,

155,
0,

158,
0,

66,
0,

266,
0,

65,
0,

123,
0,

164,
0,

185,
0,

8,
0,

140,
0,

108,
0,

222,
0,

167,
0,

212,
0,

193,
0,

141,
0,

118,
0,

112,
0,

176,
0,

177,
0,

189,
0,

217,
0,

209,
0,

6,
0,

210,
0,

69,
0,

15,
0,

68,
0,

224,
0,

172,
0,

39,
0,

180,
0,

225,
0,

149,
0,

10,
0,

169,
0,

192,
0,

138,
0,

113,
0,

166,
0,

184,
0,

197,
0,

124,
0,

12,
0,

191,
0,

228,
0,

227,
0,

111,
0,

163,
0,

181,
0,

150,
0,

174,
0,

190,
0,

211,
0,

179,
0,

13,
0,

235,
0,

237,
0,

170,
0,

161,
0,

171,
0,

226,
0,

229,
0,
0};
# define YYTYPE int
struct yywork { YYTYPE verify, advance; } yycrank[] = {
0,0,	0,0,	1,3,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	1,4,	1,5,	
7,65,	1,6,	1,7,	0,0,	
0,0,	80,79,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	1,8,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	1,9,	1,10,	
1,11,	0,0,	0,0,	1,12,	
1,13,	1,14,	1,15,	1,16,	
1,17,	1,18,	1,19,	1,20,	
1,21,	1,22,	1,23,	12,68,	
13,69,	23,73,	0,0,	0,0,	
0,0,	1,24,	0,0,	1,25,	
1,26,	1,27,	1,28,	1,29,	
1,30,	21,70,	1,31,	22,72,	
22,72,	22,72,	22,72,	22,72,	
22,72,	22,72,	22,72,	22,72,	
22,72,	27,75,	29,76,	73,181,	
0,0,	73,182,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
1,32,	1,33,	1,34,	1,35,	
1,36,	1,37,	1,38,	1,39,	
1,40,	1,41,	1,42,	1,43,	
1,44,	1,45,	1,46,	1,47,	
1,48,	1,49,	1,50,	1,51,	
1,52,	1,53,	1,54,	1,55,	
1,56,	1,57,	1,58,	1,59,	
1,60,	1,61,	1,54,	1,54,	
1,62,	2,6,	1,63,	1,64,	
21,71,	24,74,	44,121,	47,129,	
48,130,	42,114,	58,172,	61,180,	
58,173,	74,183,	85,186,	2,8,	
33,78,	33,79,	86,187,	42,115,	
33,80,	42,116,	2,9,	88,190,	
2,11,	89,191,	42,117,	2,12,	
2,13,	2,14,	2,15,	2,16,	
2,17,	2,18,	2,19,	2,20,	
2,21,	90,192,	2,23,	33,78,	
91,193,	91,194,	93,198,	96,203,	
38,85,	2,24,	38,86,	2,25,	
2,26,	2,27,	2,28,	2,29,	
2,30,	49,131,	38,87,	39,91,	
38,88,	49,132,	97,204,	39,92,	
98,205,	49,133,	43,118,	38,89,	
38,90,	46,126,	39,93,	39,94,	
43,119,	39,95,	87,188,	43,120,	
39,96,	46,127,	99,206,	39,97,	
100,207,	49,134,	87,189,	46,128,	
2,32,	2,33,	2,34,	2,35,	
101,208,	2,37,	102,209,	2,39,	
2,40,	2,41,	2,42,	2,43,	
2,44,	105,212,	2,46,	2,47,	
2,48,	2,49,	107,216,	2,51,	
2,52,	2,53,	2,54,	2,55,	
2,56,	2,57,	2,58,	2,59,	
2,60,	2,61,	2,54,	2,54,	
2,62,	10,66,	2,63,	2,64,	
40,98,	33,81,	104,210,	108,217,	
40,99,	10,66,	10,66,	40,100,	
40,101,	10,66,	104,211,	40,102,	
40,103,	109,218,	40,104,	41,107,	
41,108,	40,105,	59,174,	41,109,	
40,106,	45,122,	112,225,	41,110,	
59,175,	45,123,	52,146,	113,226,	
59,176,	41,111,	10,67,	45,124,	
41,112,	60,177,	114,227,	45,125,	
115,228,	52,147,	116,229,	41,113,	
60,178,	60,179,	106,213,	52,148,	
10,66,	31,77,	31,77,	31,77,	
31,77,	31,77,	31,77,	31,77,	
31,77,	31,77,	31,77,	106,214,	
111,223,	106,215,	117,230,	111,224,	
120,235,	10,66,	31,77,	31,77,	
31,77,	31,77,	31,77,	31,77,	
31,77,	31,77,	31,77,	31,77,	
31,77,	31,77,	31,77,	31,77,	
31,77,	31,77,	31,77,	31,77,	
31,77,	31,77,	31,77,	31,77,	
31,77,	31,77,	31,77,	31,77,	
118,231,	119,233,	119,234,	10,66,	
31,77,	10,66,	78,78,	78,79,	
123,241,	127,244,	78,80,	118,232,	
10,66,	128,246,	129,247,	130,248,	
131,249,	10,66,	36,82,	36,82,	
36,82,	36,82,	36,82,	36,82,	
36,82,	36,82,	36,82,	36,82,	
127,245,	78,78,	133,253,	134,254,	
135,255,	138,261,	142,264,	36,82,	
36,82,	36,82,	36,82,	36,82,	
36,82,	36,82,	36,82,	36,82,	
36,82,	36,82,	36,82,	36,82,	
36,82,	36,82,	36,82,	36,82,	
36,82,	36,82,	36,82,	36,82,	
36,82,	36,82,	36,82,	36,82,	
36,82,	51,140,	144,265,	145,266,	
146,267,	36,82,	147,268,	36,82,	
36,82,	36,82,	36,82,	36,82,	
36,82,	36,82,	36,82,	36,82,	
36,82,	36,82,	36,82,	36,82,	
36,82,	36,82,	36,82,	36,82,	
36,82,	36,82,	36,82,	36,82,	
36,82,	36,82,	36,82,	36,82,	
36,82,	37,83,	50,135,	55,155,	
148,269,	151,278,	50,136,	55,156,	
92,195,	152,279,	50,137,	55,157,	
57,167,	153,280,	51,141,	50,138,	
57,168,	55,158,	55,159,	92,196,	
57,169,	53,149,	50,139,	51,142,	
37,83,	53,150,	57,170,	92,197,	
53,151,	57,171,	51,143,	56,160,	
53,152,	51,144,	110,219,	53,153,	
122,239,	56,161,	53,154,	51,145,	
56,162,	154,281,	95,199,	56,163,	
155,282,	95,200,	110,220,	122,240,	
56,164,	139,262,	95,201,	56,165,	
110,221,	56,166,	95,202,	110,222,	
139,263,	37,84,	37,84,	37,84,	
37,84,	37,84,	37,84,	37,84,	
37,84,	37,84,	37,84,	37,84,	
37,84,	37,84,	37,84,	37,84,	
37,84,	37,84,	37,84,	37,84,	
37,84,	37,84,	37,84,	37,84,	
37,84,	37,84,	37,84,	84,184,	
121,236,	126,242,	132,250,	136,256,	
150,276,	137,259,	136,257,	157,287,	
121,237,	159,290,	132,251,	126,243,	
158,288,	158,289,	121,238,	137,260,	
132,252,	161,293,	150,277,	156,283,	
149,270,	149,271,	84,184,	156,284,	
149,272,	163,296,	165,299,	156,285,	
136,258,	149,273,	156,286,	149,274,	
162,294,	164,297,	160,291,	149,275,	
166,300,	164,298,	84,84,	84,84,	
84,84,	84,84,	84,84,	84,84,	
84,84,	84,84,	84,84,	84,84,	
160,292,	167,301,	168,302,	169,303,	
162,295,	170,307,	174,313,	175,314,	
171,308,	172,310,	169,304,	169,305,	
171,309,	176,315,	172,311,	177,316,	
178,318,	179,319,	169,306,	177,317,	
180,321,	183,322,	184,184,	186,323,	
172,312,	187,324,	189,325,	190,326,	
191,327,	192,328,	193,329,	194,332,	
195,333,	179,320,	196,334,	197,335,	
198,336,	84,84,	84,185,	193,330,	
193,331,	199,337,	200,338,	201,339,	
202,341,	184,184,	203,342,	204,343,	
205,344,	206,345,	201,340,	207,346,	
208,347,	209,348,	210,349,	211,350,	
212,351,	214,352,	216,353,	217,354,	
218,355,	219,357,	220,358,	221,359,	
222,360,	223,361,	218,356,	224,362,	
225,363,	226,364,	228,365,	229,366,	
230,369,	231,370,	229,367,	232,371,	
233,372,	234,373,	229,368,	235,374,	
236,375,	237,376,	238,377,	239,378,	
240,379,	241,380,	242,381,	243,242,	
244,382,	245,384,	246,385,	247,386,	
244,383,	249,387,	250,388,	253,389,	
254,390,	255,391,	256,392,	257,393,	
258,394,	259,395,	260,396,	261,397,	
262,398,	263,399,	264,401,	265,404,	
266,405,	184,185,	267,406,	268,407,	
269,408,	270,409,	272,410,	263,400,	
273,411,	274,412,	275,413,	264,402,	
276,414,	277,416,	264,403,	278,417,	
279,418,	280,419,	281,420,	282,421,	
283,422,	284,424,	285,425,	286,426,	
287,427,	288,428,	291,429,	292,430,	
293,431,	294,432,	276,415,	295,433,	
296,434,	297,435,	283,423,	298,436,	
299,437,	300,438,	301,439,	302,440,	
305,441,	306,442,	307,443,	308,445,	
309,446,	310,447,	311,448,	312,449,	
313,450,	314,451,	315,452,	316,453,	
317,454,	318,455,	319,456,	320,457,	
321,458,	322,459,	323,460,	324,461,	
326,462,	327,463,	328,464,	329,465,	
330,466,	331,467,	333,468,	334,469,	
335,470,	336,471,	337,472,	338,473,	
339,474,	340,475,	341,476,	342,477,	
343,479,	344,480,	345,481,	346,482,	
347,483,	342,478,	349,484,	350,485,	
351,486,	352,487,	353,488,	354,489,	
355,490,	356,491,	358,492,	360,493,	
361,494,	364,495,	366,496,	367,497,	
368,498,	370,500,	371,501,	372,502,	
373,503,	307,444,	374,504,	375,505,	
368,499,	376,506,	377,508,	378,509,	
379,511,	380,512,	381,513,	382,514,	
383,515,	384,516,	386,517,	387,518,	
388,519,	390,520,	376,507,	391,521,	
392,522,	378,510,	393,523,	394,524,	
396,525,	398,526,	399,527,	400,528,	
401,529,	402,530,	403,531,	404,532,	
405,533,	406,534,	407,535,	408,536,	
409,537,	409,538,	410,539,	411,541,	
412,542,	413,543,	414,544,	415,545,	
416,546,	417,547,	418,548,	419,549,	
420,550,	421,551,	422,552,	423,553,	
424,554,	410,540,	425,555,	426,556,	
427,558,	426,557,	429,559,	430,560,	
432,561,	434,562,	435,563,	436,564,	
437,565,	438,566,	439,567,	440,568,	
441,569,	442,571,	441,570,	444,572,	
445,573,	446,574,	447,575,	448,576,	
449,577,	450,578,	451,579,	452,580,	
455,581,	458,582,	459,583,	460,584,	
461,585,	462,586,	463,587,	464,588,	
465,589,	466,590,	467,591,	468,592,	
469,594,	470,595,	472,596,	473,597,	
474,598,	475,599,	478,600,	468,593,	
480,601,	481,602,	482,603,	483,604,	
484,605,	485,606,	486,607,	488,608,	
489,609,	490,610,	491,611,	492,612,	
493,613,	494,614,	495,615,	496,616,	
497,617,	499,618,	500,619,	501,620,	
502,621,	503,623,	504,624,	506,625,	
507,626,	508,629,	507,627,	509,630,	
502,622,	510,631,	511,632,	512,633,	
513,634,	514,635,	515,636,	516,637,	
517,638,	518,639,	519,640,	520,641,	
522,642,	523,643,	524,644,	526,645,	
528,646,	529,647,	507,628,	530,648,	
531,649,	532,650,	533,651,	534,652,	
535,653,	536,654,	537,655,	513,634,	
538,656,	539,657,	540,658,	541,659,	
542,660,	543,661,	545,662,	546,664,	
547,665,	549,666,	550,667,	551,668,	
552,669,	553,670,	554,671,	555,672,	
556,673,	557,674,	558,675,	560,676,	
562,678,	563,679,	560,677,	564,682,	
565,683,	563,680,	566,684,	567,685,	
563,681,	570,686,	545,663,	572,687,	
573,688,	574,689,	575,690,	578,691,	
580,692,	581,693,	583,694,	584,695,	
585,696,	586,697,	587,698,	588,699,	
589,700,	591,701,	592,702,	593,703,	
594,704,	595,705,	596,706,	597,707,	
598,708,	599,709,	600,711,	601,712,	
603,713,	575,690,	604,714,	606,715,	
607,716,	610,722,	608,717,	612,723,	
613,724,	614,725,	615,730,	617,731,	
618,732,	619,733,	620,734,	621,735,	
622,736,	623,737,	624,738,	625,739,	
626,740,	627,741,	628,742,	629,743,	
630,744,	631,745,	632,746,	633,747,	
610,722,	608,717,	634,634,	636,749,	
614,725,	637,750,	638,751,	640,752,	
641,753,	642,756,	644,757,	645,758,	
647,759,	641,754,	648,760,	649,761,	
650,762,	651,763,	653,764,	654,765,	
655,766,	656,767,	657,768,	658,769,	
659,770,	634,634,	641,755,	660,771,	
599,710,	608,718,	661,772,	662,773,	
614,726,	663,774,	664,775,	666,776,	
667,777,	669,778,	670,779,	671,780,	
672,781,	673,784,	674,785,	672,782,	
675,786,	676,787,	677,788,	678,789,	
679,790,	680,791,	681,792,	682,794,	
681,793,	683,795,	684,796,	685,797,	
686,798,	672,783,	634,748,	634,748,	
634,748,	634,748,	634,748,	634,748,	
634,748,	634,748,	634,748,	634,748,	
634,748,	634,748,	634,748,	634,748,	
634,748,	634,748,	634,748,	634,748,	
634,748,	634,748,	634,748,	634,748,	
634,748,	634,748,	634,748,	634,748,	
608,719,	608,720,	687,799,	614,727,	
614,728,	688,800,	689,801,	690,690,	
691,803,	692,804,	693,805,	608,721,	
695,806,	696,807,	614,729,	697,808,	
698,809,	699,810,	700,811,	701,812,	
702,813,	703,814,	704,815,	705,816,	
706,817,	708,818,	710,819,	712,820,	
713,821,	716,822,	690,690,	719,823,	
720,824,	722,722,	723,826,	724,827,	
727,828,	728,829,	731,830,	732,831,	
734,832,	735,833,	736,834,	738,835,	
739,836,	740,837,	741,838,	742,839,	
745,840,	746,841,	747,842,	750,844,	
751,845,	752,846,	753,847,	754,848,	
722,722,	755,849,	757,852,	758,853,	
759,854,	761,855,	762,856,	690,802,	
690,802,	690,802,	690,802,	690,802,	
690,802,	690,802,	690,802,	690,802,	
690,802,	690,802,	690,802,	690,802,	
690,802,	690,802,	690,802,	690,802,	
690,802,	690,802,	690,802,	690,802,	
690,802,	690,802,	690,802,	690,802,	
690,802,	722,825,	722,825,	722,825,	
722,825,	722,825,	722,825,	722,825,	
722,825,	722,825,	722,825,	722,825,	
722,825,	722,825,	722,825,	722,825,	
722,825,	722,825,	722,825,	722,825,	
722,825,	722,825,	722,825,	722,825,	
722,825,	722,825,	722,825,	748,748,	
748,748,	748,748,	748,748,	748,748,	
748,748,	748,748,	748,748,	748,748,	
748,748,	763,857,	764,858,	765,859,	
767,860,	768,861,	769,862,	770,863,	
748,748,	748,748,	748,748,	748,748,	
748,748,	748,748,	748,748,	748,748,	
748,748,	748,748,	748,748,	748,748,	
748,748,	748,748,	748,748,	748,748,	
748,748,	748,748,	748,748,	748,748,	
748,748,	748,748,	748,748,	748,748,	
748,748,	748,748,	749,843,	756,850,	
771,864,	772,865,	748,748,	774,866,	
776,867,	777,868,	778,869,	779,870,	
781,871,	782,872,	783,873,	785,874,	
756,851,	786,875,	787,876,	788,877,	
790,878,	791,879,	792,880,	793,881,	
795,882,	749,843,	796,883,	797,884,	
798,885,	799,886,	800,887,	802,802,	
802,802,	802,802,	802,802,	802,802,	
802,802,	802,802,	802,802,	802,802,	
802,802,	805,888,	806,889,	807,890,	
809,891,	810,892,	813,893,	814,894,	
802,802,	802,802,	802,802,	802,802,	
802,802,	802,802,	802,802,	802,802,	
802,802,	802,802,	802,802,	802,802,	
802,802,	802,802,	802,802,	802,802,	
802,802,	802,802,	802,802,	802,802,	
802,802,	802,802,	802,802,	802,802,	
802,802,	802,802,	815,895,	816,896,	
818,897,	819,898,	802,802,	820,899,	
821,900,	822,901,	823,902,	824,903,	
825,904,	826,905,	828,906,	829,907,	
830,908,	831,909,	832,910,	833,911,	
825,825,	825,825,	825,825,	825,825,	
825,825,	825,825,	825,825,	825,825,	
825,825,	825,825,	835,913,	837,914,	
838,915,	839,916,	840,917,	841,918,	
842,919,	825,825,	825,825,	825,825,	
825,825,	825,825,	825,825,	825,825,	
825,825,	825,825,	825,825,	825,825,	
825,825,	825,825,	825,825,	825,825,	
825,825,	825,825,	825,825,	825,825,	
825,825,	825,825,	825,825,	825,825,	
825,825,	825,825,	825,825,	834,912,	
843,920,	845,921,	846,922,	825,825,	
847,923,	848,924,	849,925,	850,926,	
851,927,	852,928,	853,929,	854,930,	
856,931,	857,932,	858,933,	859,934,	
861,935,	862,936,	864,937,	865,938,	
867,939,	868,940,	834,912,	869,941,	
871,942,	872,943,	873,944,	874,945,	
875,946,	878,947,	880,948,	882,949,	
883,950,	884,951,	886,952,	887,953,	
888,954,	889,955,	890,956,	892,957,	
895,958,	896,959,	898,960,	902,961,	
905,962,	906,963,	909,964,	911,965,	
912,966,	913,967,	914,968,	916,969,	
917,970,	919,971,	920,972,	922,973,	
923,974,	924,975,	925,976,	926,977,	
927,978,	928,979,	920,972,	920,0,	
930,980,	932,981,	920,0,	935,982,	
937,983,	939,984,	940,985,	942,986,	
944,987,	945,988,	946,989,	947,990,	
948,991,	950,992,	951,993,	956,994,	
959,995,	960,996,	964,997,	966,998,	
967,999,	969,1000,	971,1001,	920,0,	
974,1003,	975,1004,	972,0,	966,998,	
966,0,	972,0,	977,1005,	966,0,	
978,1006,	979,1007,	983,1008,	985,1009,	
987,1010,	920,972,	988,1011,	989,1012,	
992,1013,	993,1014,	994,1015,	995,1016,	
996,1017,	998,0,	999,1019,	1000,1020,	
998,0,	1004,1021,	972,1002,	1005,1022,	
966,0,	1007,1023,	920,972,	1008,1024,	
1009,1025,	1020,1026,	1021,1027,	1022,1028,	
1024,1029,	1026,1030,	1027,1031,	1028,1032,	
1031,1033,	1032,1034,	966,998,	1033,1035,	
1034,1036,	998,1018,	1036,1037,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	966,998,	
920,972,	0,0,	920,972,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	920,972,	0,0,	0,0,	
0,0,	0,0,	920,972,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	966,998,	0,0,	966,998,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	966,998,	0,0,	
0,0,	0,0,	0,0,	966,998,	
0,0};
struct yysvf yysvec[] = {
0,	0,	0,
yycrank+-1,	0,		0,	
yycrank+-113,	yysvec+1,	0,	
yycrank+0,	0,		yyvstop+1,
yycrank+0,	0,		yyvstop+3,
yycrank+0,	0,		yyvstop+6,
yycrank+0,	0,		yyvstop+8,
yycrank+2,	0,		yyvstop+11,
yycrank+0,	0,		yyvstop+14,
yycrank+0,	0,		yyvstop+17,
yycrank+-236,	0,		yyvstop+20,
yycrank+0,	0,		yyvstop+22,
yycrank+13,	0,		yyvstop+25,
yycrank+13,	0,		yyvstop+28,
yycrank+0,	0,		yyvstop+31,
yycrank+0,	0,		yyvstop+34,
yycrank+0,	0,		yyvstop+37,
yycrank+0,	0,		yyvstop+40,
yycrank+0,	0,		yyvstop+43,
yycrank+0,	0,		yyvstop+46,
yycrank+0,	0,		yyvstop+49,
yycrank+18,	0,		yyvstop+52,
yycrank+19,	0,		yyvstop+55,
yycrank+6,	yysvec+22,	yyvstop+58,
yycrank+13,	yysvec+22,	yyvstop+61,
yycrank+0,	0,		yyvstop+64,
yycrank+0,	0,		yyvstop+67,
yycrank+17,	0,		yyvstop+70,
yycrank+0,	0,		yyvstop+73,
yycrank+16,	0,		yyvstop+76,
yycrank+0,	0,		yyvstop+79,
yycrank+237,	0,		yyvstop+82,
yycrank+0,	0,		yyvstop+85,
yycrank+131,	0,		yyvstop+88,
yycrank+0,	0,		yyvstop+90,
yycrank+0,	0,		yyvstop+93,
yycrank+298,	0,		yyvstop+96,
yycrank+412,	0,		yyvstop+98,
yycrank+70,	0,		yyvstop+100,
yycrank+82,	0,		yyvstop+103,
yycrank+143,	0,		yyvstop+106,
yycrank+158,	0,		yyvstop+109,
yycrank+35,	0,		yyvstop+112,
yycrank+81,	0,		yyvstop+115,
yycrank+16,	0,		yyvstop+118,
yycrank+160,	0,		yyvstop+121,
yycrank+87,	0,		yyvstop+124,
yycrank+14,	0,		yyvstop+127,
yycrank+31,	0,		yyvstop+130,
yycrank+80,	0,		yyvstop+133,
yycrank+325,	0,		yyvstop+136,
yycrank+342,	0,		yyvstop+139,
yycrank+167,	0,		yyvstop+142,
yycrank+344,	0,		yyvstop+145,
yycrank+0,	0,		yyvstop+148,
yycrank+326,	0,		yyvstop+151,
yycrank+352,	0,		yyvstop+154,
yycrank+335,	0,		yyvstop+157,
yycrank+24,	0,		yyvstop+160,
yycrank+153,	0,		yyvstop+163,
yycrank+176,	0,		yyvstop+166,
yycrank+25,	0,		yyvstop+169,
yycrank+0,	0,		yyvstop+172,
yycrank+0,	0,		yyvstop+175,
yycrank+0,	0,		yyvstop+178,
yycrank+0,	0,		yyvstop+181,
yycrank+0,	yysvec+10,	0,	
yycrank+0,	0,		yyvstop+183,
yycrank+0,	0,		yyvstop+185,
yycrank+0,	yysvec+13,	yyvstop+187,
yycrank+0,	0,		yyvstop+189,
yycrank+0,	0,		yyvstop+191,
yycrank+0,	yysvec+22,	yyvstop+193,
yycrank+29,	0,		0,	
yycrank+23,	0,		0,	
yycrank+0,	0,		yyvstop+195,
yycrank+0,	0,		yyvstop+197,
yycrank+0,	yysvec+31,	yyvstop+199,
yycrank+325,	0,		0,	
yycrank+0,	0,		yyvstop+201,
yycrank+7,	0,		0,	
yycrank+0,	0,		yyvstop+203,
yycrank+0,	yysvec+36,	yyvstop+205,
yycrank+0,	yysvec+37,	0,	
yycrank+494,	yysvec+37,	0,	
yycrank+27,	0,		0,	
yycrank+42,	0,		0,	
yycrank+86,	0,		0,	
yycrank+50,	0,		0,	
yycrank+46,	0,		0,	
yycrank+64,	0,		0,	
yycrank+50,	0,		0,	
yycrank+331,	0,		0,	
yycrank+55,	0,		0,	
yycrank+0,	0,		yyvstop+207,
yycrank+354,	0,		0,	
yycrank+70,	0,		0,	
yycrank+74,	0,		0,	
yycrank+74,	0,		0,	
yycrank+88,	0,		0,	
yycrank+89,	0,		0,	
yycrank+94,	0,		0,	
yycrank+109,	0,		0,	
yycrank+0,	0,		yyvstop+209,
yycrank+133,	0,		0,	
yycrank+116,	0,		0,	
yycrank+181,	0,		0,	
yycrank+107,	0,		0,	
yycrank+135,	0,		0,	
yycrank+151,	0,		0,	
yycrank+357,	0,		0,	
yycrank+180,	0,		0,	
yycrank+145,	0,		0,	
yycrank+157,	0,		0,	
yycrank+165,	0,		0,	
yycrank+161,	0,		0,	
yycrank+178,	0,		0,	
yycrank+200,	0,		0,	
yycrank+225,	0,		0,	
yycrank+219,	0,		0,	
yycrank+199,	0,		0,	
yycrank+407,	0,		0,	
yycrank+359,	0,		0,	
yycrank+236,	0,		0,	
yycrank+0,	0,		yyvstop+211,
yycrank+0,	0,		yyvstop+213,
yycrank+405,	0,		0,	
yycrank+238,	0,		0,	
yycrank+244,	0,		0,	
yycrank+227,	0,		0,	
yycrank+222,	0,		0,	
yycrank+246,	0,		0,	
yycrank+404,	0,		0,	
yycrank+248,	0,		0,	
yycrank+245,	0,		0,	
yycrank+254,	0,		0,	
yycrank+410,	0,		0,	
yycrank+409,	0,		0,	
yycrank+244,	0,		0,	
yycrank+361,	0,		0,	
yycrank+0,	0,		yyvstop+215,
yycrank+0,	0,		yyvstop+217,
yycrank+243,	0,		0,	
yycrank+0,	0,		yyvstop+219,
yycrank+274,	0,		0,	
yycrank+282,	0,		0,	
yycrank+276,	0,		0,	
yycrank+278,	0,		0,	
yycrank+320,	0,		0,	
yycrank+425,	0,		0,	
yycrank+408,	0,		0,	
yycrank+311,	0,		0,	
yycrank+332,	0,		0,	
yycrank+318,	0,		0,	
yycrank+356,	0,		0,	
yycrank+361,	0,		0,	
yycrank+419,	0,		0,	
yycrank+408,	0,		0,	
yycrank+408,	0,		0,	
yycrank+397,	0,		0,	
yycrank+441,	0,		0,	
yycrank+399,	0,		0,	
yycrank+439,	0,		0,	
yycrank+417,	0,		0,	
yycrank+440,	0,		0,	
yycrank+425,	0,		0,	
yycrank+432,	0,		0,	
yycrank+455,	0,		0,	
yycrank+444,	0,		0,	
yycrank+454,	0,		0,	
yycrank+445,	0,		yyvstop+221,
yycrank+463,	0,		0,	
yycrank+461,	0,		0,	
yycrank+0,	0,		yyvstop+223,
yycrank+443,	0,		0,	
yycrank+454,	0,		0,	
yycrank+466,	0,		0,	
yycrank+453,	0,		0,	
yycrank+467,	0,		0,	
yycrank+469,	0,		0,	
yycrank+461,	0,		0,	
yycrank+0,	0,		yyvstop+225,
yycrank+0,	0,		yyvstop+227,
yycrank+472,	0,		0,	
yycrank+565,	0,		0,	
yycrank+0,	0,		yyvstop+229,
yycrank+457,	0,		0,	
yycrank+461,	0,		0,	
yycrank+0,	0,		yyvstop+231,
yycrank+467,	0,		yyvstop+233,
yycrank+471,	0,		0,	
yycrank+471,	0,		yyvstop+235,
yycrank+471,	0,		0,	
yycrank+477,	0,		yyvstop+237,
yycrank+468,	0,		0,	
yycrank+475,	0,		0,	
yycrank+475,	0,		0,	
yycrank+468,	0,		0,	
yycrank+489,	0,		0,	
yycrank+493,	0,		0,	
yycrank+487,	0,		0,	
yycrank+486,	0,		0,	
yycrank+495,	0,		0,	
yycrank+499,	0,		0,	
yycrank+496,	0,		0,	
yycrank+501,	0,		0,	
yycrank+485,	0,		0,	
yycrank+489,	0,		0,	
yycrank+505,	0,		0,	
yycrank+503,	0,		0,	
yycrank+497,	0,		0,	
yycrank+493,	0,		0,	
yycrank+493,	0,		0,	
yycrank+0,	0,		yyvstop+239,
yycrank+491,	0,		0,	
yycrank+0,	0,		yyvstop+241,
yycrank+506,	0,		0,	
yycrank+513,	0,		0,	
yycrank+507,	0,		0,	
yycrank+504,	0,		0,	
yycrank+509,	0,		yyvstop+243,
yycrank+499,	0,		0,	
yycrank+511,	0,		0,	
yycrank+501,	0,		0,	
yycrank+509,	0,		0,	
yycrank+511,	0,		0,	
yycrank+521,	0,		yyvstop+245,
yycrank+0,	0,		yyvstop+247,
yycrank+521,	0,		0,	
yycrank+525,	0,		0,	
yycrank+515,	0,		0,	
yycrank+527,	0,		0,	
yycrank+512,	0,		0,	
yycrank+512,	0,		0,	
yycrank+513,	0,		0,	
yycrank+521,	0,		0,	
yycrank+533,	0,		0,	
yycrank+533,	0,		0,	
yycrank+517,	0,		0,	
yycrank+535,	0,		0,	
yycrank+518,	0,		0,	
yycrank+536,	0,		0,	
yycrank+537,	0,		0,	
yycrank+539,	0,		0,	
yycrank+536,	0,		0,	
yycrank+536,	0,		0,	
yycrank+534,	0,		0,	
yycrank+527,	0,		0,	
yycrank+0,	0,		yyvstop+249,
yycrank+544,	0,		0,	
yycrank+530,	0,		0,	
yycrank+0,	0,		yyvstop+251,
yycrank+0,	0,		yyvstop+253,
yycrank+546,	0,		0,	
yycrank+543,	0,		0,	
yycrank+538,	0,		yyvstop+255,
yycrank+535,	0,		0,	
yycrank+546,	0,		0,	
yycrank+530,	0,		0,	
yycrank+548,	0,		0,	
yycrank+543,	0,		yyvstop+257,
yycrank+546,	0,		0,	
yycrank+540,	0,		0,	
yycrank+552,	0,		0,	
yycrank+559,	0,		0,	
yycrank+558,	0,		0,	
yycrank+562,	0,		yyvstop+259,
yycrank+565,	0,		0,	
yycrank+559,	0,		0,	
yycrank+563,	0,		0,	
yycrank+558,	0,		0,	
yycrank+0,	0,		yyvstop+261,
yycrank+565,	0,		0,	
yycrank+571,	0,		0,	
yycrank+568,	0,		0,	
yycrank+573,	0,		0,	
yycrank+575,	0,		0,	
yycrank+571,	0,		yyvstop+263,
yycrank+578,	0,		0,	
yycrank+571,	0,		0,	
yycrank+561,	0,		0,	
yycrank+568,	0,		0,	
yycrank+576,	0,		0,	
yycrank+579,	0,		yyvstop+265,
yycrank+580,	0,		0,	
yycrank+581,	0,		0,	
yycrank+567,	0,		0,	
yycrank+580,	0,		0,	
yycrank+577,	0,		0,	
yycrank+0,	0,		yyvstop+267,
yycrank+0,	0,		yyvstop+269,
yycrank+578,	0,		0,	
yycrank+573,	0,		0,	
yycrank+587,	0,		0,	
yycrank+574,	0,		0,	
yycrank+577,	0,		0,	
yycrank+578,	0,		0,	
yycrank+591,	0,		0,	
yycrank+586,	0,		0,	
yycrank+586,	0,		0,	
yycrank+585,	0,		0,	
yycrank+579,	0,		yyvstop+271,
yycrank+588,	0,		0,	
yycrank+0,	0,		yyvstop+273,
yycrank+0,	0,		yyvstop+275,
yycrank+599,	0,		0,	
yycrank+593,	0,		0,	
yycrank+652,	0,		yyvstop+277,
yycrank+593,	0,		0,	
yycrank+606,	0,		0,	
yycrank+604,	0,		0,	
yycrank+590,	0,		0,	
yycrank+606,	0,		0,	
yycrank+603,	0,		0,	
yycrank+610,	0,		0,	
yycrank+606,	0,		0,	
yycrank+601,	0,		0,	
yycrank+591,	0,		0,	
yycrank+599,	0,		0,	
yycrank+613,	0,		0,	
yycrank+611,	0,		0,	
yycrank+600,	0,		0,	
yycrank+619,	0,		0,	
yycrank+617,	0,		0,	
yycrank+605,	0,		0,	
yycrank+0,	0,		yyvstop+279,
yycrank+599,	0,		0,	
yycrank+620,	0,		0,	
yycrank+606,	0,		0,	
yycrank+607,	0,		0,	
yycrank+623,	0,		0,	
yycrank+609,	0,		0,	
yycrank+0,	0,		yyvstop+281,
yycrank+611,	0,		0,	
yycrank+608,	0,		0,	
yycrank+627,	0,		0,	
yycrank+622,	0,		0,	
yycrank+625,	0,		yyvstop+283,
yycrank+622,	0,		0,	
yycrank+635,	0,		0,	
yycrank+622,	0,		0,	
yycrank+634,	0,		0,	
yycrank+634,	0,		0,	
yycrank+635,	0,		0,	
yycrank+636,	0,		0,	
yycrank+637,	0,		0,	
yycrank+639,	0,		0,	
yycrank+632,	0,		0,	
yycrank+0,	0,		yyvstop+285,
yycrank+631,	0,		0,	
yycrank+638,	0,		0,	
yycrank+645,	0,		0,	
yycrank+644,	0,		0,	
yycrank+645,	0,		0,	
yycrank+650,	0,		0,	
yycrank+638,	0,		0,	
yycrank+650,	0,		0,	
yycrank+0,	0,		yyvstop+287,
yycrank+640,	0,		0,	
yycrank+0,	0,		yyvstop+289,
yycrank+636,	0,		0,	
yycrank+651,	0,		0,	
yycrank+0,	0,		yyvstop+291,
yycrank+0,	0,		yyvstop+293,
yycrank+648,	0,		0,	
yycrank+0,	0,		yyvstop+295,
yycrank+657,	0,		0,	
yycrank+645,	0,		0,	
yycrank+654,	0,		0,	
yycrank+0,	0,		yyvstop+297,
yycrank+660,	0,		0,	
yycrank+642,	0,		0,	
yycrank+657,	0,		yyvstop+299,
yycrank+659,	0,		0,	
yycrank+663,	0,		0,	
yycrank+662,	0,		0,	
yycrank+663,	0,		0,	
yycrank+654,	0,		0,	
yycrank+666,	0,		0,	
yycrank+667,	0,		0,	
yycrank+670,	0,		0,	
yycrank+668,	0,		0,	
yycrank+670,	0,		0,	
yycrank+655,	0,		0,	
yycrank+658,	0,		0,	
yycrank+0,	0,		yyvstop+301,
yycrank+669,	0,		0,	
yycrank+667,	0,		0,	
yycrank+667,	0,		yyvstop+303,
yycrank+0,	0,		yyvstop+305,
yycrank+678,	0,		0,	
yycrank+665,	0,		0,	
yycrank+670,	0,		0,	
yycrank+665,	0,		0,	
yycrank+672,	0,		0,	
yycrank+0,	0,		yyvstop+307,
yycrank+670,	0,		0,	
yycrank+0,	0,		yyvstop+309,
yycrank+680,	0,		0,	
yycrank+687,	0,		0,	
yycrank+666,	0,		0,	
yycrank+687,	0,		0,	
yycrank+692,	0,		0,	
yycrank+691,	0,		0,	
yycrank+687,	0,		0,	
yycrank+691,	0,		0,	
yycrank+675,	0,		0,	
yycrank+693,	0,		0,	
yycrank+681,	0,		0,	
yycrank+695,	0,		0,	
yycrank+694,	0,		0,	
yycrank+683,	0,		0,	
yycrank+692,	0,		0,	
yycrank+698,	0,		0,	
yycrank+694,	0,		0,	
yycrank+687,	0,		0,	
yycrank+703,	0,		0,	
yycrank+690,	0,		0,	
yycrank+696,	0,		0,	
yycrank+692,	0,		0,	
yycrank+692,	0,		0,	
yycrank+708,	0,		0,	
yycrank+713,	0,		0,	
yycrank+695,	0,		0,	
yycrank+715,	0,		0,	
yycrank+717,	0,		0,	
yycrank+718,	0,		0,	
yycrank+700,	0,		0,	
yycrank+0,	0,		yyvstop+311,
yycrank+717,	0,		0,	
yycrank+718,	0,		0,	
yycrank+0,	0,		yyvstop+313,
yycrank+716,	0,		0,	
yycrank+0,	0,		yyvstop+315,
yycrank+724,	0,		0,	
yycrank+720,	0,		0,	
yycrank+715,	0,		0,	
yycrank+721,	0,		0,	
yycrank+714,	0,		0,	
yycrank+722,	0,		0,	
yycrank+713,	0,		0,	
yycrank+713,	0,		yyvstop+317,
yycrank+728,	0,		0,	
yycrank+0,	0,		yyvstop+319,
yycrank+734,	0,		0,	
yycrank+717,	0,		0,	
yycrank+725,	0,		0,	
yycrank+732,	0,		0,	
yycrank+720,	0,		0,	
yycrank+720,	0,		0,	
yycrank+739,	0,		0,	
yycrank+737,	0,		0,	
yycrank+738,	0,		0,	
yycrank+0,	0,		yyvstop+321,
yycrank+0,	0,		yyvstop+323,
yycrank+739,	0,		0,	
yycrank+0,	0,		yyvstop+325,
yycrank+0,	0,		yyvstop+327,
yycrank+740,	0,		0,	
yycrank+734,	0,		0,	
yycrank+732,	0,		yyvstop+329,
yycrank+747,	0,		0,	
yycrank+730,	0,		0,	
yycrank+736,	0,		0,	
yycrank+744,	0,		0,	
yycrank+737,	0,		0,	
yycrank+749,	0,		0,	
yycrank+729,	0,		0,	
yycrank+743,	0,		0,	
yycrank+741,	0,		yyvstop+331,
yycrank+752,	0,		0,	
yycrank+0,	0,		yyvstop+333,
yycrank+738,	0,		0,	
yycrank+758,	0,		0,	
yycrank+742,	0,		0,	
yycrank+748,	0,		0,	
yycrank+0,	0,		yyvstop+335,
yycrank+0,	0,		yyvstop+337,
yycrank+757,	0,		0,	
yycrank+0,	0,		yyvstop+339,
yycrank+752,	0,		0,	
yycrank+747,	0,		0,	
yycrank+762,	0,		yyvstop+341,
yycrank+762,	0,		0,	
yycrank+754,	0,		0,	
yycrank+764,	0,		0,	
yycrank+766,	0,		0,	
yycrank+0,	0,		yyvstop+343,
yycrank+767,	0,		0,	
yycrank+754,	0,		0,	
yycrank+768,	0,		0,	
yycrank+754,	0,		0,	
yycrank+766,	0,		0,	
yycrank+767,	0,		0,	
yycrank+773,	0,		0,	
yycrank+759,	0,		0,	
yycrank+761,	0,		0,	
yycrank+776,	0,		0,	
yycrank+0,	0,		yyvstop+345,
yycrank+774,	0,		0,	
yycrank+763,	0,		0,	
yycrank+767,	0,		0,	
yycrank+783,	0,		0,	
yycrank+767,	0,		0,	
yycrank+778,	0,		0,	
yycrank+0,	0,		yyvstop+347,
yycrank+769,	0,		0,	
yycrank+787,	0,		yyvstop+349,
yycrank+784,	0,		0,	
yycrank+773,	0,		0,	
yycrank+785,	0,		0,	
yycrank+774,	0,		0,	
yycrank+787,	0,		0,	
yycrank+883,	0,		0,	
yycrank+778,	0,		0,	
yycrank+794,	0,		0,	
yycrank+797,	0,		0,	
yycrank+794,	0,		0,	
yycrank+847,	0,		yyvstop+351,
yycrank+801,	0,		0,	
yycrank+784,	0,		0,	
yycrank+0,	0,		yyvstop+353,
yycrank+783,	0,		0,	
yycrank+792,	0,		0,	
yycrank+787,	0,		0,	
yycrank+0,	0,		yyvstop+355,
yycrank+789,	0,		0,	
yycrank+0,	0,		yyvstop+357,
yycrank+795,	0,		0,	
yycrank+795,	0,		0,	
yycrank+804,	0,		0,	
yycrank+797,	0,		0,	
yycrank+808,	0,		0,	
yycrank+796,	0,		0,	
yycrank+810,	0,		0,	
yycrank+804,	0,		0,	
yycrank+797,	0,		0,	
yycrank+794,	0,		0,	
yycrank+819,	0,		0,	
yycrank+816,	0,		0,	
yycrank+813,	0,		0,	
yycrank+814,	0,		0,	
yycrank+805,	0,		0,	
yycrank+807,	0,		0,	
yycrank+0,	0,		yyvstop+359,
yycrank+825,	0,		0,	
yycrank+824,	0,		0,	
yycrank+823,	0,		0,	
yycrank+0,	0,		yyvstop+361,
yycrank+826,	0,		0,	
yycrank+817,	0,		yyvstop+363,
yycrank+827,	0,		0,	
yycrank+814,	0,		0,	
yycrank+808,	0,		0,	
yycrank+815,	0,		0,	
yycrank+815,	0,		0,	
yycrank+818,	0,		0,	
yycrank+822,	0,		0,	
yycrank+825,	0,		yyvstop+365,
yycrank+0,	0,		yyvstop+367,
yycrank+823,	0,		yyvstop+369,
yycrank+0,	0,		yyvstop+371,
yycrank+826,	0,		0,	
yycrank+829,	0,		yyvstop+373,
yycrank+838,	0,		0,	
yycrank+823,	0,		0,	
yycrank+827,	0,		0,	
yycrank+838,	0,		0,	
yycrank+0,	0,		yyvstop+375,
yycrank+0,	0,		yyvstop+377,
yycrank+835,	0,		0,	
yycrank+0,	0,		yyvstop+379,
yycrank+833,	0,		0,	
yycrank+836,	0,		0,	
yycrank+848,	0,		0,	
yycrank+941,	0,		0,	
yycrank+0,	0,		yyvstop+381,
yycrank+0,	0,		yyvstop+383,
yycrank+843,	0,		0,	
yycrank+0,	0,		yyvstop+385,
yycrank+843,	0,		0,	
yycrank+836,	0,		0,	
yycrank+0,	0,		yyvstop+387,
yycrank+853,	0,		0,	
yycrank+841,	0,		0,	
yycrank+846,	0,		0,	
yycrank+852,	0,		0,	
yycrank+842,	0,		0,	
yycrank+862,	0,		0,	
yycrank+850,	0,		0,	
yycrank+0,	0,		yyvstop+389,
yycrank+853,	0,		0,	
yycrank+851,	0,		0,	
yycrank+842,	0,		0,	
yycrank+850,	0,		0,	
yycrank+855,	0,		0,	
yycrank+869,	0,		0,	
yycrank+857,	0,		0,	
yycrank+865,	0,		0,	
yycrank+919,	0,		yyvstop+391,
yycrank+854,	0,		0,	
yycrank+864,	0,		0,	
yycrank+0,	0,		yyvstop+393,
yycrank+867,	0,		0,	
yycrank+874,	0,		0,	
yycrank+0,	0,		yyvstop+395,
yycrank+861,	0,		0,	
yycrank+871,	0,		0,	
yycrank+969,	0,		yyvstop+397,
yycrank+0,	0,		yyvstop+399,
yycrank+968,	0,		0,	
yycrank+0,	0,		yyvstop+401,
yycrank+864,	0,		0,	
yycrank+869,	0,		0,	
yycrank+972,	0,		yyvstop+403,
yycrank+866,	0,		0,	
yycrank+0,	0,		yyvstop+405,
yycrank+878,	0,		0,	
yycrank+869,	0,		yyvstop+407,
yycrank+870,	0,		0,	
yycrank+889,	0,		0,	
yycrank+878,	0,		0,	
yycrank+880,	0,		0,	
yycrank+939,	0,		yyvstop+409,
yycrank+872,	0,		0,	
yycrank+890,	0,		0,	
yycrank+876,	0,		0,	
yycrank+896,	0,		0,	
yycrank+890,	0,		0,	
yycrank+895,	0,		0,	
yycrank+946,	0,		yyvstop+411,
yycrank+900,	0,		0,	
yycrank+893,	0,		0,	
yycrank+902,	0,		0,	
yycrank+993,	0,		0,	
yycrank+0,	0,		yyvstop+413,
yycrank+902,	0,		0,	
yycrank+908,	0,		0,	
yycrank+901,	0,		0,	
yycrank+0,	0,		yyvstop+415,
yycrank+893,	0,		0,	
yycrank+911,	0,		yyvstop+417,
yycrank+900,	0,		0,	
yycrank+0,	0,		yyvstop+419,
yycrank+899,	0,		0,	
yycrank+910,	0,		0,	
yycrank+0,	0,		yyvstop+421,
yycrank+896,	0,		0,	
yycrank+913,	0,		0,	
yycrank+901,	0,		0,	
yycrank+919,	0,		0,	
yycrank+908,	0,		0,	
yycrank+0,	0,		yyvstop+423,
yycrank+913,	0,		0,	
yycrank+918,	0,		0,	
yycrank+908,	0,		0,	
yycrank+922,	0,		0,	
yycrank+917,	0,		0,	
yycrank+923,	0,		0,	
yycrank+914,	0,		0,	
yycrank+915,	0,		0,	
yycrank+933,	0,		0,	
yycrank+917,	0,		0,	
yycrank+925,	0,		0,	
yycrank+918,	0,		0,	
yycrank+0,	0,		yyvstop+425,
yycrank+921,	0,		0,	
yycrank+919,	0,		0,	
yycrank+0,	0,		yyvstop+427,
yycrank+922,	0,		0,	
yycrank+930,	0,		0,	
yycrank+938,	0,		0,	
yycrank+942,	0,		0,	
yycrank+925,	0,		0,	
yycrank+933,	0,		0,	
yycrank+947,	0,		0,	
yycrank+948,	0,		0,	
yycrank+945,	0,		0,	
yycrank+936,	0,		0,	
yycrank+943,	0,		0,	
yycrank+952,	0,		0,	
yycrank+951,	0,		yyvstop+429,
yycrank+941,	0,		0,	
yycrank+943,	0,		0,	
yycrank+949,	0,		0,	
yycrank+939,	0,		0,	
yycrank+951,	0,		0,	
yycrank+983,	0,		0,	
yycrank+978,	0,		0,	
yycrank+1034,	0,		yyvstop+431,
yycrank+1082,	0,		0,	
yycrank+991,	0,		0,	
yycrank+992,	0,		0,	
yycrank+979,	0,		0,	
yycrank+0,	0,		yyvstop+433,
yycrank+996,	0,		0,	
yycrank+982,	0,		0,	
yycrank+984,	0,		0,	
yycrank+999,	0,		0,	
yycrank+987,	0,		0,	
yycrank+1001,	0,		0,	
yycrank+1002,	0,		0,	
yycrank+992,	0,		0,	
yycrank+997,	0,		0,	
yycrank+1006,	0,		0,	
yycrank+996,	0,		yyvstop+435,
yycrank+1000,	0,		0,	
yycrank+0,	0,		yyvstop+437,
yycrank+1004,	0,		0,	
yycrank+0,	0,		yyvstop+439,
yycrank+1013,	0,		0,	
yycrank+0,	0,		yyvstop+441,
yycrank+1010,	0,		0,	
yycrank+997,	0,		0,	
yycrank+0,	0,		yyvstop+443,
yycrank+0,	0,		yyvstop+445,
yycrank+998,	0,		0,	
yycrank+0,	yysvec+608,	0,	
yycrank+0,	0,		yyvstop+447,
yycrank+1007,	0,		0,	
yycrank+1011,	0,		0,	
yycrank+0,	0,		yyvstop+449,
yycrank+1108,	0,		0,	
yycrank+1014,	0,		0,	
yycrank+1009,	0,		0,	
yycrank+0,	yysvec+614,	0,	
yycrank+0,	0,		yyvstop+451,
yycrank+1012,	0,		0,	
yycrank+1016,	0,		0,	
yycrank+0,	0,		yyvstop+453,
yycrank+0,	0,		yyvstop+455,
yycrank+1012,	0,		0,	
yycrank+1007,	0,		0,	
yycrank+0,	0,		yyvstop+457,
yycrank+1021,	0,		0,	
yycrank+1020,	0,		0,	
yycrank+1025,	0,		0,	
yycrank+0,	0,		yyvstop+459,
yycrank+1022,	0,		0,	
yycrank+1012,	0,		0,	
yycrank+1028,	0,		0,	
yycrank+1022,	0,		0,	
yycrank+1030,	0,		0,	
yycrank+0,	0,		yyvstop+461,
yycrank+0,	0,		yyvstop+463,
yycrank+1020,	0,		0,	
yycrank+1034,	0,		0,	
yycrank+1024,	0,		0,	
yycrank+1151,	0,		yyvstop+465,
yycrank+1233,	0,		0,	
yycrank+1021,	0,		0,	
yycrank+1035,	0,		0,	
yycrank+1034,	0,		0,	
yycrank+1030,	0,		0,	
yycrank+1028,	0,		0,	
yycrank+1036,	0,		0,	
yycrank+1141,	0,		yyvstop+467,
yycrank+1030,	0,		0,	
yycrank+1028,	0,		0,	
yycrank+1027,	0,		0,	
yycrank+0,	0,		yyvstop+469,
yycrank+1044,	0,		0,	
yycrank+1046,	0,		0,	
yycrank+1095,	0,		0,	
yycrank+1100,	0,		0,	
yycrank+1091,	0,		0,	
yycrank+0,	0,		yyvstop+471,
yycrank+1096,	0,		0,	
yycrank+1110,	0,		0,	
yycrank+1098,	0,		0,	
yycrank+1104,	0,		0,	
yycrank+1143,	0,		0,	
yycrank+1133,	0,		0,	
yycrank+0,	0,		yyvstop+473,
yycrank+1146,	0,		0,	
yycrank+0,	0,		yyvstop+475,
yycrank+1143,	0,		0,	
yycrank+1141,	0,		0,	
yycrank+1153,	0,		0,	
yycrank+1150,	0,		0,	
yycrank+0,	0,		yyvstop+477,
yycrank+1141,	0,		0,	
yycrank+1143,	0,		0,	
yycrank+1138,	0,		0,	
yycrank+0,	0,		yyvstop+479,
yycrank+1157,	0,		0,	
yycrank+1143,	0,		0,	
yycrank+1158,	0,		0,	
yycrank+1147,	0,		0,	
yycrank+0,	0,		yyvstop+481,
yycrank+1150,	0,		0,	
yycrank+1161,	0,		0,	
yycrank+1165,	0,		0,	
yycrank+1151,	0,		0,	
yycrank+0,	0,		yyvstop+483,
yycrank+1159,	0,		0,	
yycrank+1150,	0,		0,	
yycrank+1166,	0,		0,	
yycrank+1152,	0,		0,	
yycrank+1164,	0,		0,	
yycrank+1155,	0,		0,	
yycrank+0,	0,		yyvstop+485,
yycrank+1223,	0,		yyvstop+487,
yycrank+0,	0,		yyvstop+489,
yycrank+0,	0,		yyvstop+491,
yycrank+1180,	0,		0,	
yycrank+1181,	0,		0,	
yycrank+1171,	0,		0,	
yycrank+0,	0,		yyvstop+493,
yycrank+1184,	0,		0,	
yycrank+1185,	0,		0,	
yycrank+0,	0,		yyvstop+495,
yycrank+0,	0,		yyvstop+497,
yycrank+1185,	0,		0,	
yycrank+1186,	0,		0,	
yycrank+1213,	0,		0,	
yycrank+1201,	0,		0,	
yycrank+0,	0,		yyvstop+499,
yycrank+1206,	0,		0,	
yycrank+1203,	0,		0,	
yycrank+1198,	0,		0,	
yycrank+1204,	0,		0,	
yycrank+1205,	0,		0,	
yycrank+1205,	0,		0,	
yycrank+1222,	0,		0,	
yycrank+1284,	0,		yyvstop+501,
yycrank+1224,	0,		0,	
yycrank+0,	0,		yyvstop+503,
yycrank+1209,	0,		0,	
yycrank+1226,	0,		0,	
yycrank+1225,	0,		0,	
yycrank+1208,	0,		0,	
yycrank+1229,	0,		0,	
yycrank+1223,	0,		0,	
yycrank+1366,	0,		0,	
yycrank+1231,	0,		0,	
yycrank+0,	0,		yyvstop+505,
yycrank+1233,	0,		0,	
yycrank+1243,	0,		0,	
yycrank+1231,	0,		0,	
yycrank+1245,	0,		0,	
yycrank+1250,	0,		0,	
yycrank+1245,	0,		0,	
yycrank+1342,	yysvec+749,	0,	
yycrank+0,	0,		yyvstop+507,
yycrank+1277,	0,		0,	
yycrank+1273,	0,		0,	
yycrank+1275,	0,		0,	
yycrank+1271,	0,		0,	
yycrank+1260,	0,		0,	
yycrank+1272,	0,		0,	
yycrank+1279,	0,		0,	
yycrank+1271,	0,		0,	
yycrank+1270,	0,		0,	
yycrank+1273,	0,		0,	
yycrank+0,	0,		yyvstop+509,
yycrank+1273,	0,		0,	
yycrank+1277,	0,		0,	
yycrank+1289,	0,		0,	
yycrank+1275,	0,		0,	
yycrank+0,	0,		yyvstop+511,
yycrank+1288,	0,		0,	
yycrank+1289,	0,		0,	
yycrank+0,	0,		yyvstop+513,
yycrank+1280,	0,		0,	
yycrank+1291,	0,		0,	
yycrank+0,	0,		yyvstop+515,
yycrank+1284,	0,		0,	
yycrank+1281,	0,		0,	
yycrank+1291,	0,		0,	
yycrank+0,	0,		yyvstop+517,
yycrank+1284,	0,		0,	
yycrank+1301,	0,		0,	
yycrank+1305,	0,		0,	
yycrank+1298,	0,		0,	
yycrank+1301,	0,		0,	
yycrank+0,	0,		yyvstop+519,
yycrank+0,	0,		yyvstop+521,
yycrank+1304,	0,		0,	
yycrank+0,	0,		yyvstop+523,
yycrank+1298,	0,		0,	
yycrank+0,	0,		yyvstop+525,
yycrank+1291,	0,		0,	
yycrank+1303,	0,		0,	
yycrank+1311,	0,		0,	
yycrank+0,	0,		yyvstop+527,
yycrank+1300,	0,		0,	
yycrank+1310,	0,		0,	
yycrank+1312,	0,		0,	
yycrank+1299,	0,		0,	
yycrank+1303,	0,		0,	
yycrank+0,	0,		yyvstop+529,
yycrank+1314,	0,		0,	
yycrank+0,	0,		yyvstop+531,
yycrank+0,	0,		yyvstop+533,
yycrank+1302,	0,		0,	
yycrank+1317,	0,		0,	
yycrank+0,	0,		yyvstop+535,
yycrank+1315,	0,		0,	
yycrank+0,	0,		yyvstop+537,
yycrank+0,	0,		yyvstop+539,
yycrank+0,	0,		yyvstop+541,
yycrank+1305,	0,		0,	
yycrank+0,	0,		yyvstop+543,
yycrank+0,	0,		yyvstop+545,
yycrank+1320,	0,		0,	
yycrank+1307,	0,		0,	
yycrank+0,	0,		yyvstop+547,
yycrank+0,	0,		yyvstop+549,
yycrank+1314,	0,		0,	
yycrank+0,	0,		yyvstop+551,
yycrank+1302,	0,		0,	
yycrank+1390,	yysvec+834,	0,	
yycrank+1317,	0,		0,	
yycrank+1326,	0,		0,	
yycrank+0,	0,		yyvstop+553,
yycrank+1326,	0,		0,	
yycrank+1313,	0,		0,	
yycrank+0,	0,		yyvstop+555,
yycrank+1328,	0,		0,	
yycrank+-1429,	0,		0,	
yycrank+0,	0,		yyvstop+557,
yycrank+1321,	0,		0,	
yycrank+1329,	0,		0,	
yycrank+1317,	0,		0,	
yycrank+1333,	0,		0,	
yycrank+1325,	0,		0,	
yycrank+1314,	0,		0,	
yycrank+1340,	0,		0,	
yycrank+0,	0,		yyvstop+559,
yycrank+1319,	0,		0,	
yycrank+0,	0,		yyvstop+561,
yycrank+1325,	0,		0,	
yycrank+0,	0,		yyvstop+563,
yycrank+0,	0,		yyvstop+565,
yycrank+1327,	0,		0,	
yycrank+0,	0,		yyvstop+567,
yycrank+1332,	0,		0,	
yycrank+0,	0,		yyvstop+569,
yycrank+1329,	0,		0,	
yycrank+1336,	0,		0,	
yycrank+0,	0,		yyvstop+571,
yycrank+1343,	0,		0,	
yycrank+0,	0,		yyvstop+573,
yycrank+1334,	0,		0,	
yycrank+1339,	0,		0,	
yycrank+1345,	0,		0,	
yycrank+1336,	0,		0,	
yycrank+1351,	0,		0,	
yycrank+0,	0,		yyvstop+575,
yycrank+1342,	0,		0,	
yycrank+1343,	0,		0,	
yycrank+0,	0,		yyvstop+577,
yycrank+0,	0,		yyvstop+579,
yycrank+0,	0,		yyvstop+581,
yycrank+0,	0,		yyvstop+583,
yycrank+1340,	0,		0,	
yycrank+0,	0,		yyvstop+585,
yycrank+0,	0,		yyvstop+587,
yycrank+1355,	0,		0,	
yycrank+1352,	0,		0,	
yycrank+0,	0,		yyvstop+589,
yycrank+0,	0,		yyvstop+591,
yycrank+0,	0,		yyvstop+593,
yycrank+1357,	0,		0,	
yycrank+0,	0,		yyvstop+595,
yycrank+-1458,	0,		0,	
yycrank+1355,	0,		0,	
yycrank+0,	0,		yyvstop+597,
yycrank+1344,	0,		0,	
yycrank+0,	0,		yyvstop+599,
yycrank+1347,	0,		0,	
yycrank+-1456,	yysvec+920,	0,	
yycrank+0,	0,		yyvstop+601,
yycrank+1354,	0,		0,	
yycrank+1363,	0,		yyvstop+603,
yycrank+0,	0,		yyvstop+605,
yycrank+1354,	0,		0,	
yycrank+1371,	0,		0,	
yycrank+1363,	0,		0,	
yycrank+0,	0,		yyvstop+607,
yycrank+0,	0,		yyvstop+609,
yycrank+0,	0,		yyvstop+611,
yycrank+1377,	0,		0,	
yycrank+0,	0,		yyvstop+613,
yycrank+1358,	0,		0,	
yycrank+0,	0,		yyvstop+615,
yycrank+1360,	0,		0,	
yycrank+1377,	0,		0,	
yycrank+1369,	0,		0,	
yycrank+0,	0,		yyvstop+617,
yycrank+0,	0,		yyvstop+619,
yycrank+1370,	0,		0,	
yycrank+1361,	0,		0,	
yycrank+1381,	0,		0,	
yycrank+1369,	0,		0,	
yycrank+1374,	0,		0,	
yycrank+0,	0,		yyvstop+621,
yycrank+-1475,	yysvec+966,	0,	
yycrank+1376,	0,		0,	
yycrank+1372,	0,		0,	
yycrank+0,	0,		yyvstop+623,
yycrank+0,	0,		yyvstop+625,
yycrank+0,	0,		yyvstop+627,
yycrank+1392,	0,		0,	
yycrank+1389,	0,		yyvstop+629,
yycrank+0,	0,		yyvstop+631,
yycrank+1382,	0,		0,	
yycrank+1392,	0,		0,	
yycrank+1387,	0,		0,	
yycrank+0,	0,		yyvstop+633,
yycrank+0,	0,		yyvstop+635,
yycrank+0,	0,		yyvstop+637,
yycrank+0,	0,		yyvstop+639,
yycrank+0,	0,		yyvstop+641,
yycrank+0,	0,		yyvstop+643,
yycrank+0,	0,		yyvstop+645,
yycrank+0,	0,		yyvstop+647,
yycrank+0,	0,		yyvstop+649,
yycrank+0,	0,		yyvstop+651,
yycrank+1396,	0,		0,	
yycrank+1389,	0,		0,	
yycrank+1402,	0,		0,	
yycrank+0,	0,		yyvstop+653,
yycrank+1399,	0,		0,	
yycrank+0,	0,		yyvstop+655,
yycrank+1401,	0,		0,	
yycrank+1397,	0,		0,	
yycrank+1394,	0,		0,	
yycrank+0,	0,		yyvstop+657,
yycrank+0,	0,		yyvstop+659,
yycrank+1396,	0,		0,	
yycrank+1400,	0,		0,	
yycrank+1386,	0,		0,	
yycrank+1400,	0,		0,	
yycrank+0,	0,		yyvstop+661,
yycrank+1389,	0,		0,	
yycrank+0,	0,		yyvstop+663,
0,	0,	0};
struct yywork *yytop = yycrank+1567;
struct yysvf *yybgin = yysvec+1;
unsigned char yymatch[] = {
00  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,011 ,012 ,01  ,01  ,015 ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
011 ,01  ,'"' ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,
'0' ,'0' ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,01  ,01  ,01  ,01  ,'_' ,
01  ,'a' ,'a' ,'a' ,'a' ,'a' ,'a' ,'a' ,
'h' ,'h' ,'h' ,'h' ,'h' ,'m' ,'m' ,'h' ,
'h' ,'h' ,'m' ,'m' ,'h' ,'m' ,'h' ,'h' ,
'm' ,'h' ,'h' ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
0};
char yyextra[] = {
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};
int yylineno =1;
# define YYU(x) x
# define NLSTATE yyprevious=YYNEWLINE
char yytext[YYLMAX];
struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
char yysbuf[YYLMAX];
char *yysptr = yysbuf;
int *yyfnd;
extern struct yysvf *yyestate;
int yyprevious = YYNEWLINE;
#if defined(__cplusplus) || defined(__STDC__)
int yylook(void)
#else
yylook()
#endif
{
	register struct yysvf *yystate, **lsp;
	register struct yywork *yyt;
	struct yysvf *yyz;
	int yych, yyfirst;
	struct yywork *yyr;
# ifdef LEXDEBUG
	int debug;
# endif
	char *yylastch;
	/* start off machines */
# ifdef LEXDEBUG
	debug = 0;
# endif
	yyfirst=1;
	if (!yymorfg)
		yylastch = yytext;
	else {
		yymorfg=0;
		yylastch = yytext+yyleng;
		}
	for(;;){
		lsp = yylstate;
		yyestate = yystate = yybgin;
		if (yyprevious==YYNEWLINE) yystate++;
		for (;;){
# ifdef LEXDEBUG
			if(debug)fprintf(yyout,"state %d\n",yystate-yysvec-1);
# endif
			yyt = yystate->yystoff;
			if(yyt == yycrank && !yyfirst){  /* may not be any transitions */
				yyz = yystate->yyother;
				if(yyz == 0)break;
				if(yyz->yystoff == yycrank)break;
				}
			*yylastch++ = yych = input();
			if(yylastch > &yytext[YYLMAX]) {
				fprintf(yyout,"Input string too long, limit %d\n",YYLMAX);
				exit(1);
			}
			yyfirst=0;
		tryagain:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"char ");
				allprint(yych);
				putchar('\n');
				}
# endif
			yyr = yyt;
			if ( (long)yyt > (long)yycrank){
				yyt = yyr + yych;
				if (yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					if(lsp > &yylstate[YYLMAX]) {
						fprintf(yyout,"Input string too long, limit %d\n",YYLMAX);
						exit(1);
					}
					goto contin;
					}
				}
# ifdef YYOPTIM
			else if((long)yyt < (long)yycrank) {		/* r < yycrank */
				yyt = yyr = yycrank+(yycrank-yyt);
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"compressed state\n");
# endif
				yyt = yyt + yych;
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					if(lsp > &yylstate[YYLMAX]) {
						fprintf(yyout,"Input string too long, limit %d\n",YYLMAX);
						exit(1);
					}
					goto contin;
					}
				yyt = yyr + YYU(yymatch[yych]);
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"try fall back character ");
					allprint(YYU(yymatch[yych]));
					putchar('\n');
					}
# endif
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transition */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					if(lsp > &yylstate[YYLMAX]) {
						fprintf(yyout,"Input string too long, limit %d\n",YYLMAX);
						exit(1);
					}
					goto contin;
					}
				}
			if ((yystate = yystate->yyother) && (yyt= yystate->yystoff) != yycrank){
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"fall back to state %d\n",yystate-yysvec-1);
# endif
				goto tryagain;
				}
# endif
			else
				{unput(*--yylastch);break;}
		contin:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"state %d char ",yystate-yysvec-1);
				allprint(yych);
				putchar('\n');
				}
# endif
			;
			}
# ifdef LEXDEBUG
		if(debug){
			fprintf(yyout,"stopped at %d with ",*(lsp-1)-yysvec-1);
			allprint(yych);
			putchar('\n');
			}
# endif
		while (lsp-- > yylstate){
			*yylastch-- = 0;
			if (*lsp != 0 && (yyfnd= (*lsp)->yystops) && *yyfnd > 0){
				yyolsp = lsp;
				if(yyextra[*yyfnd]){		/* must backup */
					while(yyback((*lsp)->yystops,-*yyfnd) != 1 && lsp > yylstate){
						lsp--;
						unput(*yylastch--);
						}
					}
				yyprevious = YYU(*yylastch);
				yylsp = lsp;
				yyleng = yylastch-yytext+1;
				yytext[yyleng] = 0;
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"\nmatch ");
					sprint(yytext);
					fprintf(yyout," action %d\n",*yyfnd);
					}
# endif
				return(*yyfnd++);
				}
			unput(*yylastch);
			}
		if (yytext[0] == 0  /* && feof(yyin) */)
			{
			yysptr=yysbuf;
			return(0);
			}
		yyprevious = yytext[0] = input();
		if (yyprevious>0)
			output(yyprevious);
		yylastch=yytext;
# ifdef LEXDEBUG
		if(debug)putchar('\n');
# endif
		}
	}
#if defined(__cplusplus) || defined(__STDC__)
int yyback(int *p, int m)
#else
yyback(p, m)
	int *p;
#endif
{
	if (p==0) return(0);
	while (*p) {
		if (*p++ == m)
			return(1);
	}
	return(0);
}
	/* the following are only used in the lex library */
#if defined(__cplusplus) || defined(__STDC__)
int yyinput(void)
#else
yyinput()
#endif
{
	return(input());
	}
#if defined(__cplusplus) || defined(__STDC__)
void yyoutput(int c)
#else
yyoutput(c)
  int c; 
#endif
{
	output(c);
	}
#if defined(__cplusplus) || defined(__STDC__)
void yyunput(int c)
#else
yyunput(c)
   int c; 
#endif
{
	unput(c);
	}
